<!--- 
ColdFusion XML AdminAPI web services
Support CFMX6.1,7 and 8
(C)Russ Michaels
This wrapper for the components allows them to be used via regular Form POST/GET submissions
--->

<cfcontent type="text/xml">
<cfparam name="functionName">
<cfif structkeyexists(url, "functionName")>
	<cfparam name="arguments"  default = "#duplicate(url)#">
<cfelseif structkeyexists(form, "functionName")>
	<cfparam name="arguments"  default = "#duplicate(form)#">
</cfif>
<!---check IP--->
<cfset urIP=cgi.REMOTE_ADDR>
<cfset cfversion=left(server.ColdFusion.ProductVersion,1)>
<cfif cfversion EQ "6">
	<cfset APIname="cf6adminapi">
<cfelseif cfversion EQ "7">
	<cfset APIname="cf7adminapi">
<cfelseif cfversion EQ "8">
	<cfset APIname="cf8adminapi">
<cfelse>
	<cfset message=AdminAPI.SetXMLResponse("false","2","An error occured in the API. The Error was:- Unknown ColdFusion Version","")>
	<cfsavecontent variable="responseXml"><cfoutput>#message#</cfoutput></cfsavecontent>
</cfif>
<cfif isdefined('ApiName')>
	<cftry>
	<cfobject component="cfide.adminapi.webservice.#APIname#" name="AdminAPI">
	
	<cfset ipcheck=AdminAPI.checkIP(urIP)>
	<cfif ipcheck>
		<cfset result=AdminAPI.getFunctionMetaData("#functionName#")>
		<cfwddx action="wddx2cfml" input="#result#" output="metadata">
		<cfloop from="1" to="#arraylen(metadata.PARAMETERS)#" index="i">
			<cfparam name="#metadata.parameters[i].name#" default="">
		</cfloop>
		<cfinvoke component="#AdminAPI#" method="#functionName#" returnvariable="resultxml">
		<cfloop from="1" to="#arraylen(metadata.PARAMETERS)#" index="i">
	
					<cfif structkeyexists(arguments, metadata.parameters[i].name)>
						<cfinvokeargument name="#metadata.parameters[i].name#" value="#arguments[metadata.parameters[i].name]#">
					<cfelse>
						<cfinvokeargument name="#metadata.parameters[i].name#" value="">
					</cfif>
	
		</cfloop>
		</cfinvoke>
		<cfsavecontent variable="responseXml"><cfoutput>#resultxml#</cfoutput></cfsavecontent>
	<cfelse>
		<cfset message=AdminAPI.SetXMLResponse("false","2","Your IP (#urIP#) is not allowed!","")>
		<cfsavecontent variable="responseXml"><cfoutput>#message#</cfoutput></cfsavecontent>
	</cfif>
	<cfcatch>
		<!--- trap any errors --->
		<cfinvoke component="cfide.adminapi.webservice.#APIname#" method="debugger" error="#cfcatch#"></cfinvoke>
	</cfcatch>
	</cftry>
</cfif>

<cfscript>
        getPageContext().getOut().clearBuffer();
        writeOutput(responseXml);
</cfscript>
