<CFCOMPONENT displayname="cf6Adminapi" hint="Developed by Zhou@satachi.com" extends="cfide.adminapi.webservice.cf6mapping">
<cfapplication sessionmanagement="yes">
<!---for easier access, this function will return the metadata for a function--->
	<cffunction name="getFunctionMetaData" access="remote" returntype="string" hint="this method will return the metadata of a function in a WDDX packet.">
	<cfargument name="functionName" required="yes" type="string">
		<cfobject name="cf6API" component="cf6adminapi">
		<cfloop from="1" to="#arraylen(getMetadata(cf6API).functions)#" index="i">
			<cfif getMetadata(cf6API).functions[i].name EQ arguments.functionName>
				<cfset result=getMetadata(cf6API).functions[i]>
				<cfbreak>
			<cfelse>
				<cfloop from="1" to="#arraylen(getMetadata(cf6API).extends.functions)#" index="i">
				<cfif getMetadata(cf6API).extends.functions[i].name EQ arguments.functionName>
				<cfset result=getMetadata(cf6API).extends.functions[i]>
				<cfbreak>
				<cfelse>
					<cfloop from="1" to="#arraylen(getMetadata(cf6API).extends.extends.functions)#" index="i">
					<cfif getMetadata(cf6API).extends.extends.functions[i].name EQ arguments.functionName>
					<cfset result=getMetadata(cf6API).extends.extends.functions[i]>
					<cfbreak>
					<cfelse>
					  <cfloop from="1" to="#arraylen(getMetadata(cf6API).extends.extends.extends.functions)#" index="i">
						<cfif getMetadata(cf6API).extends.extends.extends.functions[i].name EQ arguments.functionName>
						<cfset result=getMetadata(cf6API).extends.extends.extends.functions[i]>
						<cfbreak>
						<!--- <cfelse>
							<cfloop from="1" to="#arraylen(getMetadata(cf6API).extends.extends.extends.extends.functions)#" index="i">
								<cfif getMetadata(cf6API).extends.extends.extends.extends.functions[i].name EQ arguments.functionName>
								<cfset result=getMetadata(cf6API).extends.extends.extends.extends.functions[i]>
								<cfbreak>
								</cfif>
							</cfloop> --->
						</cfif>
					  </cfloop>
					</cfif>
					</cfloop>
				</cfif>	
				</cfloop>
				
			</cfif>
		</cfloop>
		<cfwddx action="cfml2wddx" input="#result#" output="WDDXpacket">
	<cfreturn WDDXpacket>	
</cffunction>
	
<!---check the user ip again the ip list in the ip.cfm file--->
	<cffunction name="checkIP" access="public" returntype="boolean">
	<cfargument name="clientIP" default="#cgi.REMOTE_ADDR#" required="no">
	<cfif isdefined('session.ipok') and session.ipok>
	<cfreturn session.ipok>
	<cfelse>
		<cfset iplist = getProfileString(expandpath('./config.ini.cfm'),"default","iplist")>
		
		<cfif arguments.clientIP NEQ "">
			<cfif listfindnocase(iplist,arguments.clientIP) NEQ 0>
			<cfset session.ipok="Yes">
			<cfelse>
			<cfset session.ipok="No">
			
			</cfif>
		<cfelse>
			
			<cfset session.ipok="No">
		</cfif>
		<cfreturn session.ipok>
	</cfif>	
	
	</cffunction>
	
<cffunction name="SetXMLResponse" access="public" returntype="string" output="false">
		<cfargument name="Result" type="string" required="no" default="">
		<cfargument name="ResultCode" type="string" required="no" default="">
		<cfargument name="Message" type="string" required="no" default="">
		<cfargument name="ResultData" type="string" required="no" default="">
		 
		<cfxml variable="xmlResponse"><Response xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://tempuri.org/"><cfoutput><cfif arguments.result NEQ ""><Result>#arguments.result#</Result><cfelse><Result/></cfif><cfif arguments.ResultCode NEQ ""><ResultCode>#arguments.ResultCode#</ResultCode><cfelse><ResultCode/></cfif><cfif arguments.Message NEQ ""><Message>#arguments.Message#</Message><cfelse><Message/></cfif>
<cfif arguments.ResultData NEQ ""><ResultData>#arguments.ResultData#</ResultData><cfelse><ResultData/></cfif></cfoutput></Response></cfxml>
<!---log the error/success message to  AdminAPI log file--->
		<cflog text="XML response as following:#toString(xmlResponse)#" file="AdminAPI" application="yes">
<cfreturn toString(xmlResponse)></cffunction>

<cffunction name="XMLtoWDDX" access="public" returntype="string" output="false" hint="transfer xml to wddx">
		<cfargument name="XmlResponse" required="yes" type="string">
		
		<cfset leftpos=find("<wddxPacket version=",arguments.XmlResponse)>
		<cfset rightPos=find("</wddxPacket>",arguments.XmlResponse)>
		<cfif leftpos NEQ 0 and rightPos NEQ 0>
		<cfset wddx=mid(arguments.XmlResponse,leftpos,rightpos-leftpos+13)>
		<cfreturn wddx>
		<cfelse>
		<cfreturn "">
		</cfif>
		
</cffunction>	

<!---adminstrator login function--->
	<cffunction name="adminLogin" access="private" returntype="boolean">
	<!---pass in the adminpassword--->
	<cfargument name="login" required="Yes"/>
	<CFSET cfAdmin=createObject("component", "cfide.administrator.components.administrator") />
	<CFSET isLoggedIn=cfAdmin.login("#login#") />
	<cfreturn isLoggedIn />
	</cffunction>	
<!-------------------------------end of share methods----------------------------------->

	<cffunction name="debugger" access="private">
	<cfargument name="error" required="false" type="struct">
	<cfset debug = GetProfileString(ExpandPath('config.ini.cfm'),"default","debug")>
	<cfif debug>
		<cfsavecontent variable="log">
		<hr>
		DEBUG: <cfoutput>#dateformat(now(),'dddd dd mmm yyyy')# #timeformat(now(), 'hh:mm tt')#</cfoutput>
		<hr>
		<cfdump var="#form#" label="form scope">
		<cfdump var="#url#" label="URL scope">
		<fieldset><legend>Response XML</legend>
		<cfdump var="#responseXML#">
		</fieldset>
		</cfsavecontent>
		<cfif fileExists('#expandpath('./')#debuglog.html')>
		<cffile action="APPEND" file="#expandpath('./')#debuglog.html" output="#log#" addnewline="Yes" fixnewline="No">
		<cfelse>
		<cffile action="WRITE" file="#expandpath('./')#debuglog.html" output="#log#" addnewline="Yes" fixnewline="No">
		</cfif>
	</cfif>
	<cfif structkeyexists(arguments, "error")>
		<!--- log any errors --->
		<cfsavecontent variable="log">
		<hr>
		ERROR: <cfoutput>#dateformat(now(),'dddd dd mmm yyyy')# #timeformat(now(), 'hh:mm tt')#</cfoutput>
		<hr>
		<cfdump var="#form#" label="form scope">
		<cfdump var="#url#" label="URL scope">
		<cfdump var="#cfcatch#" label="cfcatch">
		</cfsavecontent>
		<cfif fileExists('#expandpath('./')#errorlog.html')>
		<cffile action="APPEND" file="#expandpath('./')#errorlog.html" output="#log#" addnewline="Yes" fixnewline="No">
		<cfelse>
		<cffile action="WRITE" file="#expandpath('./')#errorlog.html" output="#log#" addnewline="Yes" fixnewline="No">
		</cfif>
		<cfset message=AdminAPI.SetXMLResponse("false","2","An error occured in the API, please check the errorlog.html file in your adminAPI folder. The Error was:- #cfcatch.message#","")>
		<cfsavecontent variable="responseXml"><cfoutput>#message#</cfoutput></cfsavecontent>
		<cfreturn responseXML>
	</cfif>

	</cffunction>

</cfcomponent>