<CFCOMPONENT displayname="cf6Datasource" hint="Developed by Zhou@satachi.com" extends="cfide.adminapi.webservice.cf6SandBox">




<CFFUNCTION name="getDSN" access="remote" returntype="any" hint="Get the detail of a datasource. The returned information is a WDDX string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="name" type="string" required="no" hint="Specifies the data source name. Or use * to retrive a list of all datasource names"> 
		<!--- <cfargument name="dsnname" type="string" required="no" hint="Specifies the data source name. Or use * to retrive a list of all datasource names"> --->
		<cfset arguments.dsnname=trim(arguments.name)>
		<cfset structdelete(arguments,"name")>
		<cfset dsnname=arguments.dsnname>
		<!---login with admin password--->
		<cfif checkIP()>
		<!---check if log in--->
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
			<!---if dsn is provided, retrieve information for it --->
			<cfif dsnname EQ "*">
				<!---get all DSN as a list--->
				<CFINVOKE component="#datasource#" method="getDatasource" returnvariable="Datasources"/>		
				<cfset DSNList=structKeyList(datasources)>
				<cfreturn DSNList>
			<cfelse>
				<CFINVOKE component="#datasource#" method="getDatasources" returnvariable="Datasources"/>		
				<cfset DSNList=structKeyList(datasources)>
				<cfif listfindnocase(DSNList,arguments.dsnname) NEQ 0>
				<CFINVOKE component="#datasource#" method="getDatasources" returnvariable="Datasource">
					<cfinvokeargument name="dsnname" value="#dsnname#">
				</cfinvoke>
				<cfwddx action="cfml2wddx" input="#Datasource#" output="DSNdetail">
				<!--- <cfset wddx=xmlparse(DSNdetail)>
				<cfset datastring=tostring(wddx.xmlroot.data)>
				<cfset wddxDataText=right(datastring,len(datastring)-find("<data>",datastring)+1)> --->
				<!---transfer the wddx response to xml response--->
				<cfset message=SetXMLResponse("true","0","OK","#DSNdetail#")>
				<cfreturn message>
				<cfelse>
				<cfset message=SetXMLResponse("false","2","This DSN doesn't exist")>
				<cfreturn message>
				</cfif>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</cfif>
	</cffunction>

<!---insert/update access database--->
	<cffunction name="setMSAccessDSN" access="remote" returntype="any" hint="Creates or modifies a Microsoft Access data source.">
	<!---all the arguments for MS Access DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion data source name.">
	<cfargument name="databasefile" required="yes" type="string" hint="Fully qualified path to the file containing the Access MDB file.">
	<cfargument name="systemdatabasefile" required="no" default="" type="string" hint="For secure access to the database file, specify the fully qualified path name of the database that contains database security information. The system database is usually located in winnt\system32\system.mdw.">
	<cfargument name="username" required="no" default="System" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint=" Data source description">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSAccess" type="string">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string">
	<cfargument name="port" required="no" default="19996" type="string">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="UseTrustedConnection" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="defaultusername" required="no" default="" type="string">
	<cfargument name="maxBufferSize" required="no" type="any" hint="numeric value only">	
	<cfargument name="pageTimeout" required="no" default="600" type="any" hint="numeric value only">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="Boolean value only">
	<cfargument name="timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="interval" required="no" type="any" hint="numeric value only">
	<cfargument name="login_timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="blob_buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="enablemaxconnections" required="no" type="any" hint="Boolean value only">
	<cfargument name="maxconnections" required="no" type="any" hint="numeric value only">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<!---change the argument names to the origial names--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	
	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	<!---login with admin password--->
	<!---check if log in--->
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>
	
	<!---pass arguments to cf6 component--->
	<cftry>
	
	<cfinvoke component="#datasource#" method="setMSAccess">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>

	
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
		<cfset VerifyDsn = "NO">
		<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output success message--->
		<cfset message=SetXMLResponse("true","0","OK","DatasourceName=#name#")>
		 <cfreturn message>

		<CFELSE>
			<cfif not FileExists(ExpandPath(arguments.databasefile))>
			<cfset errormessage="database file path is invalid">
			<cfelse>
			<cfset errormessage="#errorMessage#">
			</cfif>
			
			<cfif DSNOperation EQ "update">
			<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
		 		<cfset message=SetXMLResponse("false","02","#errormessage#","DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>

				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK","DatasourceName=#name#")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","02","#errormessage#","DatasourceName=#name#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</cfif>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</CFFUNCTION>
	
	<!---insert/set MSAccess Unicode datasource--->
	<cffunction name="setMSAccessUnicode" access="remote" returntype="String" hint=" Creates or modifies a Microsoft Access Unicode data source.">
		<!---all the arguments forMSAccess Unicode DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="databasefile" required="yes" type="string" hint="database name that corresponds to the data source. ">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSAccessJet" type="string">
	<cfargument name="class" required="no" default="com.inzoom.jdbcado.Driver" type="string">
	<cfargument name="port" required="no" default="19996" type="string">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="UseTrustedConnection" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="defaultusername" required="no" default="" type="string">
	<cfargument name="maxBufferSize" required="no" type="any" hint="numeric value only">	
	<cfargument name="pageTimeout" required="no" default="600" type="any" hint="numeric value only">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="Boolean value only">
	<cfargument name="timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="interval" required="no" type="any" hint="numeric value only">
	<cfargument name="login_timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="blob_buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="enablemaxconnections" required="no" type="any" hint="Boolean value only">
	<cfargument name="maxconnections" required="no" type="any" hint="numeric value only">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change argument name to DSN--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	
	
	<cfif isdefined('encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"port")>
	<cfset structdelete(arguments,"UseTrustedConnection")>
	<cfset structdelete(arguments,"defaultusername")>
	<cfset structdelete(arguments,"maxBufferSize")>
	<cfset structdelete(arguments,"pageTimeout")>
	<cfset structdelete(arguments,"TimeStampAsString")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf6 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setMSAccessJet">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---function for add/update MSSQL DSN--->
	<cffunction name="setMSSQLDSN" access="remote" returntype="any" hint=" Creates or modifies a Microsoft SQL Server data source.">
		<!---all the arguments for MS SQL DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="database" required="yes" type="string" hint="Database name that corresponds to the data source.">
	<cfargument name="port" required="no" default="1433" type="string" hint="Port that is used to access the database server. (default 1433)">
	<cfargument name="username" required="no" default="System" type="string" hint=" Database username">
	<cfargument name="password" required="no" default="" type="string" hint=" Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Ignored in coldfusion mx/6 server">
	<cfargument name="vendor" required="no" default="sqlserver" type="string" hint="Ignored in coldfusion mx/6 server">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSSQLServer" type="string">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string">
	<cfargument name="encryptpassword" required="no" default="" type="any" hint="in cf6 server. this means confirmation password, must be the same as password (default is password) ">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="sendStringParametersAsUnicode" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="selectmethod" required="no" default="direct" type="string">
	<cfargument name="MaxPooledStatements" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="timeout" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="interval" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="login_timeout" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="buffer" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="blob_buffer" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="enablemaxconnections" required="no" type="string" hint="only Boolean value allowed">
	<cfargument name="maxconnections" required="no" type="string" hint="only numeric value allowed">	
	<cfargument name="pooling" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="disable" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="disable_clob" required="no" type="string" hint="only Boolean value allowed">
	<cfargument name="disable_blob" required="no" type="string" hint="only Boolean value allowed">
	<cfargument name="select" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="create" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="grant" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="insert" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="drop" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="revoke" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="update" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="alter" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="storedproc" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="delete" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change arguments name to the orginalnames--->
	<cfset arguments.dsn=arguments.name>
	<cfset structdelete(arguments,"name")>
	
	<!--- selectMethod needs to be direct to work with sql2005, so if it doesn't exist, set it --->
	<cfifarguments.selectMethod is ""><cfset arguments.selectMethod="direct"></cfif>	
	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfif isdefined('arguments.disable_clob')>
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	</cfif>
	
	<cfif isdefined('arguments.disable_blob')>
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	</cfif>
	
	<!---delete arguments which doesn't exist in cf6 cfc--->
	<cfif isdefined('arguments.type')>
	<cfset structdelete(arguments,"type")>
	</cfif>
	<cfif isdefined('arguments.vendor')>
	<cfset structdelete(arguments,"vendor")>
	</cfif>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<!---login with admin password--->
	<!---check if log in--->
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>
	
	
	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	 <cftry> 
	 <cfinvoke method="addDSN">
		<cfloop collection="#arguments#" item="key">
			<cfif isdefined('arguments.'&key) and evaluate("arguments."&key) NEQ "">
				<cfif ucase(key) NEQ "HOST">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
				<cfelse>
			<cfinvokeargument name="host" value="#arguments.host#">
				</cfif>
			</cfif>
		</cfloop>
	</CFINVOKE> 



	<!---verify DSN--->

	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	
		<cfset ErrorMessage=cfcatch.Type&":"&cfcatch.message&cfcatch.Detail>
		
		<cfset VerifyDsn="NO">
	</cfcatch>
	</cftry>  
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
				<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#ErrorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")> 
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
		 		
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#ErrorMessage#","Operation=MS SQL DSN add,DatasourceName=#name#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>
	
	<cffunction name="getNewDSNDefaults">
	<cfargument name="scope" required="true">

	<cfparam name="arguments.scope.username" default="">
	<cfparam name="arguments.scope.password" default="">
	<cfparam name="arguments.scope.description" default="">
	<cfparam name="arguments.scope.url" default="">

		<cfparam name="arguments.scope.urlmap.host" default="">
		<cfparam name="arguments.scope.urlmap.port" default="">
		<cfparam name="arguments.scope.urlmap.database" default="">
		<cfparam name="arguments.scope.urlmap.args" default="">
		<cfparam name="arguments.scope.urlmap.informixServer" default="">
		<cfparam name="arguments.scope.urlmap.selectMethod" default="direct">
		<cfparam name="arguments.scope.urlmap.SID" default="">
		<cfparam name="arguments.scope.urlmap.defaultusername" default="">
		<cfparam name="arguments.scope.urlmap.defaultpassword" default="">
		<cfparam name="arguments.scope.urlmap.maxBufferSize" default="">	
		<cfparam name="arguments.scope.urlmap.databaseFile" default="">
		<cfparam name="arguments.scope.urlmap.systemDatabaseFile" default="">
		<cfparam name="arguments.scope.urlmap.pageTimeout" default="">
		<cfparam name="arguments.scope.urlmap.datasource" default="">	
		<cfparam name="arguments.scope.urlmap.UseTrustedConnection" default="false">
		<cfparam name="arguments.scope.urlmap.sendStringParametersAsUnicode" default="false">
		<cfparam name="arguments.scope.urlmap.TimeStampAsString" default="no">
		<cfparam name="arguments.scope.urlmap.MaxPooledStatements" default="1000">
		
	<cfreturn arguments.scope>
</cffunction>
	
	<!---insert mysql datasource--->
	<cffunction name="setMySQL" access="remote" returntype="String" hint="Creates or modifies a MySQL 3.x data source.">
		<!---all the arguments for MS SQL DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="port" required="no" type="string" default="3306" hint="port number of mysql database">
	<cfargument name="database" required="yes" type="string" hint="Database name that corresponds to the data source.">
	<cfargument name="username" required="no" default="" type="string" hint=" Database username">
	<cfargument name="password" required="no" default="" type="string" hint=" Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="MySQL" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change argument name to original--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	
	
	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf6 admin API--->
	
	
	<cftry>
	<!---this use java service factory--->
	 <cfinvoke method="addDSN">
	 	<cfinvokeargument name="driver" value="MySQL">
		<cfinvokeargument name="port" value="3306">
		<cfloop collection="#arguments#" item="key">
			<cfif isdefined('arguments.'&key) and evaluate("arguments."&key) NEQ "">
				<cfif ucase(key) NEQ "HOST">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
				<cfelse>
			<cfinvokeargument name="host" value="#arguments.host#">
				</cfif>
			</cfif>
		</cfloop>
	</CFINVOKE> 
	<!---this use components--->
	<!---cfinvoke component="#datasource#" method="setMySQL">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE--->
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
		<cfset VerifyDsn = "NO">
		<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK","Operation=MySQL Datasource update,DatasourceName=#name#")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnErrorOnUpdate value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK","Operation=MySQL Datasource update,DatasourceName=#name#")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MySQL DSN add,DatasourceName=#name#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert Oracle datasource--->
	<cffunction name="setOracle" access="remote" returntype="String" hint="Creates or modifies a MySQL 3.x data source.">
		<!---all the arguments for Oracle DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="sid" required="yes" type="string" hint="The Oracle System Identifier that refers to the instance of the Oracle database software running on the server. ORCL is the default.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="port" required="no" type="string" default="1521" hint="Port that is used to access the database server. (default 1521)">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="oracle" type="string" hint="Always Oracle. Ignored in coldfusion mx/6 server">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. Ignored in coldfusion mx/6 server">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="Oracle" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change argument name to original--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	

	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"type")>
	<cfset structdelete(arguments,"vendor")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf6 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setOracle">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>
	
	<!---insert/set DB2 datasource--->
	<cffunction name="setDB2" access="remote" returntype="String" hint="Creates or modifies a DB2 data source. Refer to the ColdFusion documentation or ColdFusion MX Administrator online Help for a list of supported DB2 versions.">
		<!---all the arguments for DB2 DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="port" required="no" type="string" default="50000" hint="Port used to access the database server. The default is 50000.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="db2" type="string" hint="Always DB2. Ignored in coldfusion mx/6 server">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek.Ignored in coldfusion mx/6 server ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="DB2" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="initargs" required="no" default="" type="string" hint="Initialization connection string arguments, formatted (arg1=arg1value;arg2=arg2value).  ">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<!---change arugments from 7 to 6--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	
	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>

	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"type")>
	<cfset structdelete(arguments,"vendor")>

<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setDB2">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
		 		<cfset message=SetXMLResponse("false","2","#errorMessage#")>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>

				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set Sybase datasource--->
	<cffunction name="setSybase" access="remote" returntype="String" hint="Creates or modifies a Sybase data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="port" required="no" type="string" default="5000" hint="Port used to access the database server. The default is 5000.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="sybase" type="string" hint="Always sybase.Ignored in coldfusion mx/6 server ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek.Ignored in coldfusion mx/6 server ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="sybase" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="selectmethod" required="no" default="direct" type="string" hint=" Select Method (direct or cursor). ">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change arugments from 7 to 6--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	

	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>

	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"type")>
	<cfset structdelete(arguments,"vendor")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setSybase">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set Informix datasource--->
	<cffunction name="setInformix" access="remote" returntype="String" hint="Creates or modifies an Informix data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="InformixServer" required="yes" type="string" hint="Name of the Informix server that corresponds to the data source.">
	<cfargument name="port" required="no" type="string" default="1526" hint="Port used to access the database server. The default is 1526.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
		<cfargument name="vendor" required="no" default="informix" type="string" hint="Always sybase. Ignored in coldfusion mx/6 server">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. Ignored in coldfusion mx/6 server">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="informix" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---change arugments from 7 to 6--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	<cfif isdefined('arguments.encrytpassword')>
	<cfset structdelete(arguments,"encrytpassword")>
	</cfif>
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>

	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"type")>
	<cfset structdelete(arguments,"vendor")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	
	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf6 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setInformix">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set ODBC datasource--->
	<cffunction name="setODBCSocket" access="remote" returntype="String" hint=" Creates or modifies an ODBC socket data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="useTrustedConnection" required="no" type="string" hint="If selected, causes ODBC driver to use the credentials specified in the ODBC connection or the network login id. ">
	<cfargument name="datasource" required="yes" type="string" hint="name of ODBC datasource, defined in the server control panel. ">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="port" required="no" default="19996" type="string" hint="Port that is used to access the database server. (default 19996)  ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="ODBCSocket" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="host" required="no" default="true" type="any" hint="Database server host name or IP address.">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	
	<!---change arugments from 7 to 6--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>

	
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>

	<!---dete arguments which doesn't exist in cf6 cfc--->
	<cfset structdelete(arguments,"MaxPooledStatements")>
	<cfset structdelete(arguments,"useTrustedConnection ")>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>

	

	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	<cftry>
	<cfinvoke component="#datasource#" method="setODBCSocket">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<cfcatch type="any">
	<cfset VerifyDsn = "NO">
	<cfset errorMessage=cfcatch.Message>
	</cfcatch>
	</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
			<cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
		<!---insert/set other datasource--->
	<cffunction name="setOther" access="remote" returntype="String" hint="Creates or modifies a user-defined data source">
		<!---all the arguments for Other--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="url" required="Yes" type="string" hint="The JDBC Connection URL for this data source.">
	<cfargument name="class" required="yes" type="string" hint="JDBC class file.">
	<cfargument name="driver" required="no" default="" type="string" hint="JDBC driver">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="epassword" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="Yes" default="cursor" type="string" hint="A description for this data source connection. ">
	<cfargument name="selectmethod" required="no" default="" type="string" hint="Select Method (direct or cursor). ">
	<cfargument name="port" required="no" default="1433" type="string" hint="Port that is used to access the database server. (default 1433)  ">
		<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" default="false" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" default="" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" default="" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	
	<!---cfif isdefined('arguments.JDBCurl')>
		<cfset arguments.URL=arguments.JDBCUrl>
		<cfset structdelete(arguments,"JDBCUrl")>
	</cfif--->
	<cfif isdefined('arguments.encryptpassword')>
	<cfset structdelete(arguments,"encryptpassword")>
	</cfif>
	
	<cfswitch expression="#ucase(arguments.disable_clob)#">
		<cfcase value="YES">
		<cfset arguments.enable_clob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_clob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_clob")>
	
	<cfswitch expression="#ucase(arguments.disable_blob)#">
		<cfcase value="YES">
		<cfset arguments.enable_blob="NO">
		</cfcase>
		<cfdefaultcase>
		<cfset arguments.enable_blob="YES">
		</cfdefaultcase>
	</cfswitch>
	<cfset structdelete(arguments,"disable_blob")>
	
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset arguments.DSN=arguments.name>
	<cfset structdelete(arguments,"name")>
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>
<!----------use java service factory to add other db------------->
<cftry>
	<cfset sqlexecutive = factory.getDataSourceService()>
	<cfscript>
		////////////
		/// get the current datasource instance
		if( structKeyExists(sqlexecutive.datasources, arguments.originaldsn) )
		{
			thisdsn = duplicate(sqlexecutive.datasources[arguments.originaldsn]);
		}else {
			thisdsn = structNew();
		}

		//get default settings
		thisdsn = getNewDSNDefaults(scope=thisdsn);
		thisdsn = getCFSettingDefaults(scope=thisdsn);
		thisdsn = getDatasourceDefaults(scope=thisdsn, dsn=arguments.dsn);

		//basic values
		thisdsn.name = trim(arguments.dsn);
		thisdsn.url = trim(arguments.url);
		thisdsn.driver = trim(arguments.driver);
		thisdsn.class = trim(arguments.class);
		thisdsn.username = trim(arguments.username);
		thisdsn.password=trim(arguments.password);
		if (len(trim(arguments.epassword)))
		{
			if (arguments.epassword eq arguments.password)
			{
				thisdsn.password = arguments.epassword;
			}
			else if (len(trim(arguments.password)))
			{
				newPass = sqlexecutive.encryptPassword(arguments.password);
				thisdsn.password = newPass;
			}
			else
			{
				thisdsn.password = "";
			}
		}
		else if (arguments.epassword neq arguments.password)
		{
			newPass = sqlexecutive.encryptPassword(arguments.password);
			thisdsn.password = newPass;
		}
		else
		{
			thisdsn.password = "";
		}

		thisdsn.description = arguments.description;
		
		
				
		if(isDefined("arguments.args") )
			{thisDSN.urlmap.args = arguments.args;}
			else if( isDefined("thisDSN.urlmap.args") )
				{arguments.args = thisDSN.urlmap.args;}
				else {arguments.args = "";}	
				
				
		/////////////////////////////////////////////////////////
		/// create the connectionProps struct.
		thisDSN.urlmap.connectionProps = structNew();

			//add the connection args as name/value pairs to the struct.
			if( isDefined("arguments.args") )
			{		
				for( i=1; i lte listLen(arguments.args, ";"); i=i+1 )
				{
					thisListItem = listGetAt(arguments.args, i, ";");
					thisDSN.urlmap.connectionProps[listFirst(thisListItem, "=")] = listLast(thisListItem, "=");
				}
			}



		if(isdefined("arguments.DSN"))
		{
			//advanced settings		
			if( isDefined("arguments.timeout") )
				{ thisdsn.timeout = val(arguments.timeout) * 60; }
				else { thisdsn.timeout = 0; }
			if( isDefined("arguments.interval") )
				{ thisdsn.interval =  val(arguments.interval) * 60; }
				else { thisdsn.interval = 0; }
			if( isDefined("arguments.login_timeout") )
				{ thisdsn.login_timeout = val(arguments.login_timeout); }
				else { thisdsn.login_timeout = 0; }
			if( isDefined("arguments.buffer") ) 
				{thisdsn.buffer = val(arguments.buffer);}
			if( isDefined("arguments.blob_buffer") ) 
				{thisdsn.blob_buffer = val(arguments.blob_buffer);}

			if( isDefined("arguments.enablemaxconnections") and isNumeric(arguments.maxconnections)  )
				{thisDSN.urlmap.maxconnections=arguments.maxconnections;}
				else{ 
					//delete the struct key if it exists - no key=use default
					structDelete( thisDSN.urlmap, "maxconnections", false );
				}
				
				
			//check boxes
			if( isDefined("arguments.pooling") ) 
				{thisdsn.pooling = true;}
				else {thisdsn.pooling = false;}
			if( isDefined("arguments.disable") ) 
				{thisdsn.disable = true;}
				else {thisdsn.disable = false;}
			if( isDefined("arguments.enable_clob") ) 
				{thisdsn.disable_clob = false;}
				else {thisdsn.disable_clob = true;}
			if( isDefined("arguments.enable_blob") ) 
				{thisdsn.disable_blob = false;}
				else {thisdsn.disable_blob = true;}
			if( isDefined("arguments.select") ) 
				{thisdsn.select = true;}
				else {thisdsn.select = false;}
			if( isDefined("arguments.create") ) 
				{thisdsn.create = true;}
				else {thisdsn.create = false;}
			if( isDefined("arguments.grant") ) 
				{thisdsn.grant = true;}
				else {thisdsn.grant = false;}
			if( isDefined("arguments.insert") ) 
				{thisdsn.insert = true;}
				else {thisdsn.insert = false;}
			if( isDefined("arguments.drop") ) 
				{thisdsn.drop = true;}
				else {thisdsn.drop = false;}
			if( isDefined("arguments.revoke") ) 
				{thisdsn.revoke = true;}
				else {thisdsn.revoke = false;}
			if( isDefined("arguments.update") ) 
				{thisdsn.update = true;}
				else {thisdsn.update = false;}
			if( isDefined("arguments.alter") ) 
				{thisdsn.alter = true;}
				else {thisdsn.alter = false;}
			if( isDefined("arguments.storedproc") ) 
				{thisdsn.storedproc = true;}
				else {thisdsn.storedproc = false;}
			if( isDefined("arguments.delete") ) 
				{thisdsn.delete = true;}
				else {thisdsn.delete = false;}
		}



		/////////////////////////////////////////////////////////////////////////
		// remove the original datasource if this name was changed during an edit
		if( arguments.dsn neq arguments.originaldsn )
		{
			structDelete(sqlexecutive.datasources, arguments.originaldsn, false);
		}
		
		//////////////////
		// update the dsn
		//cfdump(var=thisdsn);
		 dsService = CreateObject("java", "coldfusion.server.ServiceFactory").DataSourceService;
		dsService.datasources[arguments.dsn] = thisdsn;
	</cfscript>
	

	<!--- <CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setOther">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE> --->
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
		<cfcatch type="any">
		<cfset VerifyDsn = "NO">
		<cfset errorMessage=cfcatch.Message>
		</cfcatch>

</cftry>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("Operation=Other Datasource update,Status=OK, DatasourceName=#name#")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","#errorMessage#","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","#errorMessage#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	

		
	
	
	<!---install odbc--->
	<cffunction name="installOdbcService" access="remote" returntype="String" hint=" Installs ODBC service.">
	<cfargument name="adminPassword" type="string" required="yes">
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<cfif not isdefined('datasource')>
	<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
	</cfif>
	<cfset installresult=datasource.installOdbcService(server.COLDFUSION.ROOTDIR)>
	<cfset message=SetXMLResponse("true","0","OK")>
	<cfreturn message>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	<cffunction name="getCFSettingDefaults">
	<cfargument name="scope" required="true">
	<cfscript>
	///////////////////////////////////////////////
	//cfsetting Defaults
	if(IsDefined("sqlexecutive.defaults")) 
		{ stDefaults = sqlexecutive.defaults; }
	else 
		{ stDefaults = StructNew(); }
		//loop over and set defaults to stDsn.scope
		for( key in stDefaults )
		{
			arguments.scope[key] = stDefaults[key];
		}	
	</cfscript>
	
	<cfreturn arguments.scope>
</cffunction>
<cffunction name="getDatasourceDefaults">
	<cfargument name="scope" required="true">
	<cfargument name="dsn" required="true">
	<cfscript>
	///////////////////////////////////////////////
	//override defaults with dsn specific data
	if(IsDefined("sqlexecutive.datasources") and structKeyExists(sqlexecutive.datasources, arguments.dsn)) 
		{ stDatasource = sqlexecutive.datasources[arguments.dsn]; }
	else 
		{ stDatasource = StructNew(); }
		//loop over and set values to stDsn.scope
		for( key in stDatasource )
		{
			arguments.scope[key] = stDatasource[key];
		}	
	</cfscript>

	<cfreturn arguments.scope>
</cffunction>
<cffunction name="getURLDefaults">
	<cfargument name="scope" required="true">
	<cfargument name="driver" default="" required="false">
	<cfargument name="delims" required="true">
	
	<cfscript>
	////////////////////////////////////////////////
	/// set the defaults from the dsn URL values.
		if( isDefined("arguments.driver") and structKeyExists(sqlexecutive.drivers, arguments.driver) )
		{
			if(IsDefined("sqlexecutive.drivers")) 
				{ stDriver = sqlexecutive.drivers[arguments.driver]; }
			else 
				{ stDriver = StructNew(); }
				
				
			if( isDefined("arguments.scope.url") and isDefined("stDriver.url")) 
			{
			
				cfdump(var="#stDriver.url#<br>");
				cfdump(var=arguments.scope.url);
				hostPos = ListFindNoCase(stDriver.url, "[host]", delims);
				portPos = ListFindNoCase(stDriver.url, "[port]", delims);
				datasourcePos = ListFindNoCase(stDriver.url, "[datasource]", delims);
				databasePos = ListFindNoCase(stDriver.url, "[database]", delims);
				argPos = ListFindNoCase(stDriver.url, "[args]", ";:?");
				selectMethodPos = ListFindNoCase(stDriver.url, "[selectmethod]", delims);
				informixPos = ListFindNoCase(stDriver.url, "[informix_server]", delims);
				sidPos = ListFindNoCase(stDriver.url, "[sid]", delims);
		
				if( hostPos and hostPos lte listLen(arguments.scope.url, delims) ) 
					{arguments.scope.host = replace(listGetAt(arguments.scope.url, hostPos, delims), "//", "");}
					
				if( portPos and portPos lte listLen(arguments.scope.url, delims) ) 
					{arguments.scope.port = listGetAt(arguments.scope.url, portPos, delims);}
					
				if( databasePos and databasePos lte listLen(arguments.scope.url, delims) ) 
					{arguments.scope.database = listGetAt(arguments.scope.url, databasePos, delims);}
					
				if( datasourcePos and datasourcePos lte listLen(arguments.scope.url, delims) ) 
					{arguments.scope.datasource = listGetAt(arguments.scope.url, datasourcePos, delims);}
					
				if( selectMethodPos and selectMethodPos lte listLen(arguments.scope.url, delims) )
					{arguments.scope.selectMethod = listGetAt(arguments.scope.url, selectMethodPos, delims);}
					
				if( argPos and argPos lte listLen(arguments.scope.url, ";:?")  )
					{arguments.scope.args = listGetAt(arguments.scope.url, argPos, ";:?");}
					
				if( informixPos and informixPos lte listLen(arguments.scope.url, delims)  )
					{arguments.scope.informixserver = listGetAt(arguments.scope.url, informixPos, delims);}
					
				if( sidPos and sidPos lte listLen(arguments.scope.url, delims)  )
					{arguments.scope.sid = listGetAt(arguments.scope.url, sidPos, delims);}
					
			}
		}
	</cfscript>
	
	<cfreturn arguments.scope>
</cffunction>
<cffunction name="formatJdbcURL">
	<cfargument name="driver" required="true">
	<cfargument name="host" required="false">
	<cfargument name="port" required="false">
	<cfargument name="dsn" required="false">
	<cfargument name="database" required="false">
	<cfargument name="args" required="false">
	<cfargument name="informixServer" required="false">
	<cfargument name="selectMethod" required="false">
	<cfargument name="SID" required="false">
	<cfargument name="MaxPooledStatements" required="false" >
	
	<!--- ///	get defaults	/// --->
	<cfset stDriver = sqlexecutive.drivers[driver]>
		
	<!--- ///	get default URL	/// --->
	<cfset thisURL = stDriver.url>

	<cfscript>
	/////////////////////////////
	/// insert host data
		if( FindNoCase("[host]", thisURL) and isDefined("arguments.host") )
		{
			if ( trim(arguments.host) neq ""  )
			{
				thisURL = ReplaceNoCase(thisURL, "[host]", listFirst(arguments.host, ":"));
			}else {
				thisURL = ReplaceNoCase(thisURL, "[host]", "localhost");
			}
		}
	///////////////////////////////
	/// insert port
		if( FindNoCase("[port]", thisURL) and isDefined("arguments.port") )
		{
			if ( Trim(arguments.port) neq "" )
			{
				thisURL = ReplaceNoCase(thisURL, "[port]", val(Trim(arguments.port)));
			}else if ( isDefined("stDriver.port") and not len(Trim(stDriver.port)) ) {
				thisURL = ReplaceNoCase(thisURL, "[port]", Trim(stDriver.port));
			}
		}		
		
	///////////////////////////////////////
	//databoase or datasource should be passed in depending on driver.
	//database is optional
		if( FindNoCase("[database]", thisURL) and isDefined("arguments.database")  )
		{		
			if ( Trim(arguments.database) neq "" )
			{
				thisURL = ReplaceNoCase(thisURL, "[database]", Trim(arguments.database));
			}else {
				thisURL = ReplaceNoCase(thisURL, "[database]", "");
				thisURL = ReplaceNoCase(thisURL, "databaseName=", "");
			}
		}
	
	///////////////////////////////////////	
	//datasource / dsn is optional
		if( FindNoCase("[datasource]", thisURL) and isDefined("arguments.datasource")  )
		{	
			if ( Trim(arguments.datasource) neq "" )
			{
				thisURL = ReplaceNoCase(thisURL, "[datasource]", Trim(arguments.datasource));
			}else {
				thisURL = ReplaceNoCase(thisURL, "[datasource]", "");
				thisURL = ReplaceNoCase(thisURL, "serverDatasource=", "");
			}
		}
			
	/////////////////////////////////
	//args are optional
		if( FindNoCase("[args]", thisURL) and isDefined("arguments.args") )
		{	
			if( Trim(arguments.args) neq "" ) 
			{
				thisURL = ReplaceNoCase(thisURL, "[args]", arguments.args, "All");
			}else {
				thisURL = ReplaceNoCase(thisURL, "[args]", "", "All");
			}
		}
				
	/////////////////////////////////////////////////////////////
	//informix server is optional (Informix)
		if( FindNoCase("[informix_server]", thisURL) and isDefined("arguments.informixServer") )
		{	
			if ( Trim(arguments.informixServer) IS NOT "" )
			{
				thisURL = ReplaceNoCase(thisURL, "[informix_server]", Trim(arguments.informixServer));
			}else {
				thisURL = ReplaceNoCase(thisURL, "[informix_server]", "");
				thisURL = ReplaceNoCase(thisURL, "informixServer=", "");
			}
		}
		
	/////////////////////////////////////
	//sid is optional (oracle)
		if( FindNoCase("[sid]", thisURL) and isDefined("arguments.SID") )
		{	
			if ( Trim(arguments.SID) IS NOT "" )
			{
				thisURL = ReplaceNoCase(thisURL, "[sid]", Trim(arguments.SID));
			}else {
				thisURL = ReplaceNoCase(thisURL, "[sid]", "");
				thisURL = ReplaceNoCase(thisURL, "SID=", "");
			}
		}
		
	//////////////////////////////////////////////
	/// insert select method (Sybase and SQL)
		if( FindNoCase("[selectmethod]", thisURL) and isDefined("arguments.selectMethod") )
		{			
			//select method is optional
			if( Trim(arguments.selectMethod) IS NOT "" ) 
			{
				thisURL = ReplaceNoCase(thisURL, "[selectmethod]", arguments.selectMethod, "All");
			}else {
				thisURL = ReplaceNoCase(thisURL, "[selectmethod]", "", "All");
				thisURL = ReplaceNoCase(thisURL, "SelectMethod=", "");			
			}
		}
		
	////////////////////////////////////////////////////////////
	/// insert sendStringParametersAsUnicode all merant drivers.
		if( FindNoCase("[sendStringParametersAsUnicode]", thisURL) and isDefined("arguments.sendStringParametersAsUnicode") )
		{			
			//select method is optional
			if( Trim(arguments.sendStringParametersAsUnicode) IS NOT "" ) 
			{
				thisURL = ReplaceNoCase(thisURL, "[sendStringParametersAsUnicode]", arguments.sendStringParametersAsUnicode, "All");
			}else {
				thisURL = ReplaceNoCase(thisURL, "[sendStringParametersAsUnicode]", "false", "All");
			}
		}
		
		
	////////////////////////////////////////////////////////////
	/// insert database file for jdbcado bridge
		if( FindNoCase("[databasefile]", thisURL) and isDefined("arguments.databasefile") )
		{			
			thisURL = ReplaceNoCase(thisURL, "[databasefile]", replace(arguments.databasefile, "\", "\\", "all"), "All");
		}
		
	//////////////////////////////////////////////////////////////
	//// add MaxPooledStatements to datadirect jdbc url, this isn't in the default jdbc url.
		if( isDefined("arguments.MaxPooledStatements") )
		{
			thisURL = thisURL &";MaxPooledStatements=#arguments.MaxPooledStatements#";
		}

		//HACK! Lists don't handle empty items very well... *sigh*
		//need to: Check PostgreSQL delimits args with ; or &. Also, make this RegEx soon!
		//Trim semi-colon from end of URL
		thisURL = ListChangeDelims(thisURL, ";", ";");
	</cfscript>
	
	<cfreturn thisURL>
	
</cffunction>
<cffunction name="addDSN" access="private" returntype="any">

	<cfargument name="dsn" required="Yes" type="string" hint="ColdFusion datasource name">
		<cfargument name="host"  required="Yes" type="string" hint="database server host name or ip">
		<cfargument name="database"  required="Yes" type="string" hint="database name that corresponds to the data source.">

		<!--- ::	optional	:: --->
		<cfargument name="originaldsn" default="" required="No" type="string" hint="original ColdFusion datasource name, if you are renaming this dsn.">
		<cfargument name="port" default="1433" required="No" type="string" hint="port that is used to access the database server. (default 1433)">
		<cfargument name="driver" default="MSSQLServer" required="No" type="string" hint="JDBC driver">
		<cfargument name="class" default="macromedia.jdbc.MacromediaDriver" required="No" type="string" hint="JDBC class file">
		<cfargument name="username" default="" required="No" type="string">
		<cfargument name="password" default="" required="No" type="string">
		<cfargument name="epassword" default="" required="No" type="string" hint="confirmation password, must be the same as password (default is password)">
		<cfargument name="description" default="" required="No" type="string">
		<cfargument name="args"  required="No" type="string" hint="connection sting arguments format like this (arg1=argvalue;arg2=argvalue)">
		<cfargument name="sendStringParametersAsUnicode" required="No" type="boolean" hint="Enable Unicode for data sources configured for non-Latin characters ">
		<cfargument name="selectmethod" default="cursor"  required="Yes" type="string" hint="Select Method (direct or cursor)">
		<cfargument name="MaxPooledStatements" required="No" type="integer" hint="Set the max number of pooled statements.">
		<!--- ::	advanced options	:: --->
		<cfargument name="timeout" required="No" type="numeric" hint="a time, in minutes, that the server allows a data source connection to remain inactive before closing that connection.">
		<cfargument name="interval" required="No" type="numeric" hint="a time, in minutes, that the server waits before closing an expired data source connection.">
		<cfargument name="login_timeout" required="No" type="numeric" hint="Login Timeout (sec)">
		<cfargument name="buffer" required="No" type="numeric" hint="Long Text Buffer (chr - default 64000)">
		<cfargument name="blob_buffer" required="No" type="numeric" hint="Blob Buffer(bytes)">
		<cfargument name="enablemaxconnections" required="No" type="boolean" hint="enable limit Connections">
		<cfargument name="maxconnections" required="No" type="numeric" hint="Limit Connections to this max amount">
		<cfargument name="pooling" required="No" type="boolean" hint="enable server connection pooling for your data source.">
		<cfargument name="disable" required="No" type="boolean" hint="disable connections to data sources.">
		<cfargument name="enable_clob" required="No" type="boolean" hint="enable long text retrieval.">
		<cfargument name="enable_blob" required="No" type="boolean" hint="enable binary large object retrieval.">
		<cfargument name="select" required="No" type="boolean" hint="allow sql SELECT statements">
		<cfargument name="create" required="No" type="boolean" hint="allow sql CREATE statements">
		<cfargument name="grant" required="No" type="boolean" hint="allow sql GRANT statements">
		<cfargument name="insert" required="No" type="boolean" hint="allow sql INSERT statements">
		<cfargument name="drop" required="No" type="boolean" hint="allow sql DROP statements">
		<cfargument name="revoke" required="No" type="boolean" hint="allow sql REVOKE statements">
		<cfargument name="update" required="No" type="boolean" hint="allow sql UPDATE statements">
		<cfargument name="alter" required="No" type="boolean" hint="allow sql ALTER statements">
		<cfargument name="storedproc" required="No" type="boolean" hint="allow sql stored procedure calls">
		<cfargument name="delete" required="No" type="boolean" hint="allow sql DELETE statements">
<cfobject action="CREATE"
		type="JAVA"
		class="coldfusion.server.ServiceFactory"
		name="factory">
<cfset sqlexecutive = factory.getDataSourceService()>
	<cfscript>
		////////////
		/// get the current datasource instance
		
		if( structKeyExists(sqlexecutive.datasources, arguments.originaldsn) )
		{
			thisdsn = duplicate(sqlexecutive.datasources[arguments.originaldsn]);
		}else {
			thisdsn = structNew();
		}

		//get default settings
		thisdsn = getNewDSNDefaults(scope=thisdsn);
		thisdsn = getCFSettingDefaults(scope=thisdsn);
		thisdsn = getDatasourceDefaults(scope=thisdsn, dsn=arguments.dsn);

		//get the selectMethod value from the URL if one exists.
		thisdsn.driver = arguments.driver;
		temp = structNew();
		
		//basic values
		thisdsn.name = arguments.dsn;
		thisdsn.driver = arguments.driver;
		thisdsn.class = arguments.class;
		thisdsn.username = arguments.username;

		if (len(trim(arguments.epassword)))
		{
			if (arguments.epassword eq arguments.password)
			{
				thisdsn.password = arguments.epassword;
			}
			else if (len(trim(arguments.password)))
			{
				newPass = sqlexecutive.encryptPassword(arguments.password);
				thisdsn.password = newPass;
			}
			else
			{
				thisdsn.password = "";
			}
		}
		else if (arguments.epassword neq arguments.password)
		{
			newPass = sqlexecutive.encryptPassword(arguments.password);
			thisdsn.password = newPass;
		}
		else
		{
			thisdsn.password = "";
		}
		
		thisdsn.description = arguments.description;

		//URL properties
		if(isDefined("arguments.host") )
			{thisDSN.urlmap.host = arguments.host;}
			else if( isDefined("thisDSN.urlmap.host") )
				{arguments.host = thisDSN.urlmap.host;}
				else {arguments.host = "";}
				
		if(isDefined("arguments.port") )
			{thisDSN.urlmap.port = val(arguments.port);}
			else if( isDefined("thisDSN.urlmap.port") )
				{arguments.port = thisDSN.urlmap.port;}
				else {arguments.port = "";}
				
		if(isDefined("arguments.database") )
			{thisDSN.urlmap.database = arguments.database;}
			else if( isDefined("thisDSN.urlmap.database") )
				{arguments.database = thisDSN.urlmap.database;}
				else {arguments.database = "";}
				
		if(isDefined("arguments.selectMethod") )
			{thisDSN.urlmap.selectmethod = arguments.selectmethod;}
			else if( isDefined("thisDSN.urlmap.selectmethod") )
				{arguments.selectMethod = thisDSN.urlmap.selectmethod;}
				else {arguments.selectMethod = "cursor";}
				
		if(isDefined("arguments.sendStringParametersAsUnicode") )
			{thisDSN.urlmap.sendStringParametersAsUnicode = arguments.sendStringParametersAsUnicode;}
			else if( isDefined("thisDSN.urlmap.sendStringParametersAsUnicode") and (not isDefined("arguments.advancedmode") or not arguments.advancedmode) )
				{arguments.sendStringParametersAsUnicode = thisDSN.urlmap.sendStringParametersAsUnicode;}
				else {
					arguments.sendStringParametersAsUnicode = false;
					thisDSN.urlmap.sendStringParametersAsUnicode = false;
				}
				
		
		if(isDefined("arguments.MaxPooledStatements") )
			{thisDSN.urlmap.MaxPooledStatements = arguments.MaxPooledStatements;}
			else if( isDefined("thisDSN.urlmap.MaxPooledStatements") and (not isDefined("arguments.advancedmode") or not arguments.advancedmode) )
				{arguments.MaxPooledStatements = thisDSN.urlmap.MaxPooledStatements;}
				else {
					arguments.MaxPooledStatements = 0;
					thisDSN.urlmap.MaxPooledStatements = 0;
				}
				
	
		/////////
		///format the jdbc URL
		form = getURLDefaults(scope=form, delims=":;=");
		thisdsn.url = formatJdbcURL(
			driver = arguments.driver
			, dsn = arguments.dsn
			, database = arguments.database
			, host = arguments.host
			, port = arguments.port
			, selectmethod = arguments.selectmethod
			, sendStringParametersAsUnicode = arguments.sendStringParametersAsUnicode
			, MaxPooledStatements = arguments.MaxPooledStatements
		);

		//clear old crap
		thisDSN.urlmap.connectionProps = StructNew();

		/////////////////////////////////////////////////////////
		/// create the connectionProps struct.
		thisDSN.urlmap.connectionProps.database = arguments.database;
		thisDSN.urlmap.connectionProps.host = arguments.host;
		thisDSN.urlmap.connectionProps.port = arguments.port;
		thisDSN.urlmap.connectionProps.selectmethod = arguments.selectmethod;
		thisDSN.urlmap.connectionProps.sendStringParametersAsUnicode = arguments.sendStringParametersAsUnicode;
		thisDSN.urlmap.connectionProps.MaxPooledStatements = arguments.MaxPooledStatements;
		
			//add the connection args as name/value pairs to the struct.
			if( isDefined("arguments.args") )
			{		
				for( i=1; i lte listLen(arguments.args, ";"); i=i+1 )
				{
					thisListItem = listGetAt(arguments.args, i, ";");
					thisDSN.urlmap.connectionProps[listFirst(thisListItem, "=")] = listLast(thisListItem, "=");
				}
			}
		

		if( isDefined("arguments.advancedmode") and arguments.advancedmode )
		{
			//advanced settings		
			if( isDefined("arguments.timeout") )
				{ thisdsn.timeout = val(arguments.timeout) * 60; }
				else { thisdsn.timeout = 0; }
			if( isDefined("arguments.interval") )
				{ thisdsn.interval =  val(arguments.interval) * 60; }
				else { thisdsn.interval = 0; }
			if( isDefined("arguments.login_timeout") )
				{ thisdsn.login_timeout = val(arguments.login_timeout); }
				else { thisdsn.login_timeout = 0; }
			if( isDefined("arguments.buffer") ) 
				{thisdsn.buffer = val(arguments.buffer);}
			if( isDefined("arguments.blob_buffer") ) 
				{thisdsn.blob_buffer = val(arguments.blob_buffer);}
				
			if( isDefined("arguments.enablemaxconnections") and isNumeric(arguments.maxconnections)  )
				{thisDSN.urlmap.maxconnections=arguments.maxconnections;}
				else{ 
					//delete the struct key if it exists - no key=use default
					structDelete( thisDSN.urlmap, "maxconnections", false );
				}
				
				
			//check boxes
			if( isDefined("arguments.pooling") ) 
				{thisdsn.pooling = true;}
				else {thisdsn.pooling = false;}
			if( isDefined("arguments.disable") ) 
				{thisdsn.disable = true;}
				else {thisdsn.disable = false;}
			if( isDefined("arguments.enable_clob") ) 
				{thisdsn.disable_clob = false;}
				else {thisdsn.disable_clob = true;}
			if( isDefined("arguments.enable_blob") ) 
				{thisdsn.disable_blob = false;}
				else {thisdsn.disable_blob = true;}
			if( isDefined("arguments.select") ) 
				{thisdsn.select = true;}
				else {thisdsn.select = false;}
			if( isDefined("arguments.create") ) 
				{thisdsn.create = true;}
				else {thisdsn.create = false;}
			if( isDefined("arguments.grant") ) 
				{thisdsn.grant = true;}
				else {thisdsn.grant = false;}
			if( isDefined("arguments.insert") ) 
				{thisdsn.insert = true;}
				else {thisdsn.insert = false;}
			if( isDefined("arguments.drop") ) 
				{thisdsn.drop = true;}
				else {thisdsn.drop = false;}
			if( isDefined("arguments.revoke") ) 
				{thisdsn.revoke = true;}
				else {thisdsn.revoke = false;}
			if( isDefined("arguments.update") ) 
				{thisdsn.update = true;}
				else {thisdsn.update = false;}
			if( isDefined("arguments.alter") ) 
				{thisdsn.alter = true;}
				else {thisdsn.alter = false;}
			if( isDefined("arguments.storedproc") ) 
				{thisdsn.storedproc = true;}
				else {thisdsn.storedproc = false;}
			if( isDefined("arguments.delete") ) 
				{thisdsn.delete = true;}
				else {thisdsn.delete = false;}
		}

		

		/////////////////////////////////////////////////////////////////////////
		// remove the original datasource if this name was changed during an edit
		if( arguments.dsn neq arguments.originaldsn )
		{
			structDelete(sqlexecutive.datasources, arguments.originaldsn, false);
		}
		
		//////////////////
		// update the dsn
		//cfdump(var=thisdsn);
		sqlexecutive.datasources[arguments.dsn] = thisdsn;
	</cfscript>
	
</cffunction>
<!---function for delete dsn--->
	<cffunction name="deleteDSN" access="remote" returntype="string" hint="delete datasource in coldfusion">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="name" required="Yes" type="any" hint="Specifies the coldfusion datasource name which you want to delete">
		<cfset arguments.dsnname=trim(arguments.name)>
		<cfset structdelete(arguments,"name")>
		<cfset dsnname=arguments.dsnname>
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfset DSNlist=getDSN(adminpassword,"*")>
		<cfif listfindnocase(DSNlist,arguments.dsnname) NEQ 0>
		<CFOBJECT component="cfide.administrator.components.datasource" name="datasource">
		<!---pass arguments to cf6 admin API--->
		<cfinvoke component="#datasource#" method="deleteDatasource">
			<cfinvokeargument name="dsnname" value="#arguments.dsnname#">
		</cfinvoke>
		<cfset message=SetXMLResponse("true","0","OK")>
	 	<cfreturn message>
		<cfelse>
		<cfset message=setXMLResponse("false","2","DSN doesn't exist")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 	<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 		<cfreturn message>
		</CFIF>
	</cffunction>	
</cfcomponent>