<cfcomponent displayname="cf7Datasource" hint="manage coldfusion data sources" extends="cfide.adminapi.webservice.cf7SandBox">
<!---get any DSN information function--->
	<CFFUNCTION name="getDSN" access="remote" returntype="any" hint="Get the detail of a datasource. The returned information is a WDDX string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="name" type="string" required="no" hint="Specifies the data source name. Or use * to retrive a list of all datasource names"> 
		<!--- <cfargument name="dsnname" type="string" required="no" hint="Specifies the data source name. Or use * to retrive a list of all datasource names"> --->
		<cfset arguments.dsnname=trim(arguments.name)>
		<cfset structdelete(arguments,"name")>
		<cfset dsnname=arguments.dsnname>
		<!---login with admin password--->
		<cfif checkIP()>
		<!---check if log in--->
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
			<!---if dsn is provided, retrieve information for it --->
			<cfif dsnname EQ "*">
				<!---get all DSN as a list--->
				<CFINVOKE component="#datasource#" method="getDatasources" returnvariable="Datasources"/>		
				<cfset DSNList=structKeyList(datasources)>
				<cfreturn DSNList>
			<cfelse>
				<CFINVOKE component="#datasource#" method="getDatasources" returnvariable="Datasources"/>		
				<cfset DSNList=structKeyList(datasources)>
				<cfif listfindnocase(DSNList,arguments.dsnname) NEQ 0>
				<CFINVOKE component="#datasource#" method="getDatasources" returnvariable="Datasource">
					<cfinvokeargument name="dsnname" value="#dsnname#">
				</cfinvoke>
				<cfwddx action="cfml2wddx" input="#Datasource#" output="DSNdetail">
				<!--- <cfset wddx=xmlparse(DSNdetail)>
				<cfset datastring=tostring(wddx.xmlroot.data)>
				<cfset wddxDataText=right(datastring,len(datastring)-find("<data>",datastring)+1)> --->
				<!---transfer the wddx response to xml response--->
				<cfset message=SetXMLResponse("true","0","OK","#DSNdetail#")>
				<cfreturn message>
				<cfelse>
				<cfset message=SetXMLResponse("false","2","This DSN doesn't exist")>
				<cfreturn message>
				</cfif>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</cfif>
	</cffunction>	

	<!---insert/update access database--->
	<cffunction name="setMSAccessDSN" access="remote" returntype="any" hint=" Creates or modifies a Microsoft Access data source.">
	<!---all the arguments for MS Access DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion data source name.">
	<cfargument name="databasefile" required="yes" type="string" hint="Fully qualified path to the file containing the Access MDB file.">
	<cfargument name="systemdatabasefile" required="no" default="" type="string" hint="For secure access to the database file, specify the fully qualified path name of the database that contains database security information. The system database is usually located in winnt\system32\system.mdw.">
	<cfargument name="username" required="no" default="System" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint=" Data source description">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSAccess" type="string">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string">
	<cfargument name="port" required="no" default="19996" type="string">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="UseTrustedConnection" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="defaultusername" required="no" default="" type="string">
	<cfargument name="maxBufferSize" required="no" type="any" hint="numeric value only">	
	<cfargument name="pageTimeout" required="no" default="600" type="any" hint="numeric value only">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="Boolean value only">
	<cfargument name="timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="interval" required="no" type="any" hint="numeric value only">
	<cfargument name="login_timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="blob_buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="enablemaxconnections" required="no" type="any" hint="Boolean value only">
	<cfargument name="maxconnections" required="no" type="any" hint="numeric value only">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<!---login with admin password--->
	<!---check if log in--->
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>
	
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setMSAccess">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output success message--->
		<cfset message=SetXMLResponse("true","0","OK","DatasourceName=#name#")>
		 <cfreturn message>

		<CFELSE>
			<cfif not FileExists(ExpandPath(arguments.databasefile))>
			<cfset errormessage="database file path is invalid">
			<cfelse>
			<cfset errormessage="invalid input info">
			</cfif>
			
			<cfif DSNOperation EQ "update">
			<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
		 		<cfset message=SetXMLResponse("false","02","#errormessage#","DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>

				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK","DatasourceName=#name#")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","02","#errormessage#","DatasourceName=#name#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</cfif>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</CFFUNCTION>

	<!---insert/set MSAccess Unicode datasource--->
	<cffunction name="setMSAccessUnicode" access="remote" returntype="String" hint=" Creates or modifies a Microsoft Access Unicode data source.">
		<!---all the arguments forMSAccess Unicode DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="databasefile" required="yes" type="string" hint="database name that corresponds to the data source. ">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSAccessJet" type="string">
	<cfargument name="class" required="no" default="com.inzoom.jdbcado.Driver" type="string">
	<cfargument name="port" required="no" default="19996" type="string">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="UseTrustedConnection" required="no" default="true" type="any" hint="Boolean value only">
	<cfargument name="defaultusername" required="no" default="" type="string">
	<cfargument name="maxBufferSize" required="no" type="any" hint="numeric value only">	
	<cfargument name="pageTimeout" required="no" default="600" type="any" hint="numeric value only">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="Boolean value only">
	<cfargument name="timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="interval" required="no" type="any" hint="numeric value only">
	<cfargument name="login_timeout" required="no" type="any" hint="numeric value only">
	<cfargument name="buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="blob_buffer" required="no" type="any" hint="numeric value only">
	<cfargument name="enablemaxconnections" required="no" type="any" hint="Boolean value only">
	<cfargument name="maxconnections" required="no" type="any" hint="numeric value only">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	<cfinvoke component="#datasource#" method="setMSAccessUnicode">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	



	<!---function for add/update MSSQL DSN--->
	<cffunction name="setMSSQLDSN" access="remote" returntype="any" hint=" Creates or modifies a Microsoft SQL Server data source.">

		<!---all the arguments for MS SQL DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="database" required="yes" type="string" hint="Database name that corresponds to the data source.">
	<cfargument name="port" required="no" default="1433" type="string" hint="Port that is used to access the database server. (default 1433)">
	<cfargument name="username" required="no" default="System" type="string" hint=" Database username">
	<cfargument name="password" required="no" default="" type="string" hint=" Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="type" required="no" default="ddtek" type="string">
	<cfargument name="vendor" required="no" default="sqlserver" type="string">
	<cfargument name="originaldsn" required="no" default="" type="string">
	<cfargument name="driver" required="no" default="MSSQLServer" type="string">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Boolean value allowed">
	<cfargument name="args" required="no" default="" type="string">
	<cfargument name="sendStringParametersAsUnicode" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="selectmethod" required="no" default="Direct" type="string">
	<cfargument name="MaxPooledStatements" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="timeout" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="interval" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="login_timeout" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="buffer" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="blob_buffer" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="enablemaxconnections" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="maxconnections" required="no" type="any" hint="only numeric value allowed">	
	<cfargument name="pooling" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="disable" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="disable_clob" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="disable_blob" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="select" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="create" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="grant" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="insert" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="drop" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="revoke" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="update" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="alter" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="storedproc" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="delete" required="no" type="any" hint="only Boolean value allowed">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	
	<cftry>
	<cfset debugger(arguments)>
	<!--- remove any blank arguments --->
	<cfloop collection="#arguments#" item="key">
		<cfif arguments[key] eq "">
		<cfset structDelete(arguments,key)>
		</cfif>
	</cfloop>
	<!--- selectMethod needs to be direct to work with sql2005, so if it doesn't exist, set it --->
	<cfif NOT structKeyExists(arguments, "selectMethod")><cfset arguments.selectMethod="direct"></cfif>
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<!---login with admin password--->
	<!---check if log in--->
	<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!---check if DSN already exist--->
		<cfset DSNList=getDSN(adminpassword,"*")>
		<cfif listfindnocase(DSNList,name) EQ 0>
			<cfset DSNOperation="add">
		<cfelse>
			<cfset DSNOperation="update">
		</cfif>
	
		<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
		<!---pass arguments to cf7 admin API--->
		
		<cfinvoke component="#datasource#" method="setMSSQL" argumentcollection="#arguments#">

		</CFINVOKE>
		<!---verify DSN--->
		<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
			<CFINVOKEARGUMENT name="dsn" value="#name#">
		</CFINVOKE>
		<!---pass back whether the update is successful--->
			<CFIF VerifyDsn EQ "YES">
			<!---if the DSN pass the verify, output the DSN detail as a structure--->
			 <cfset message=SetXMLResponse("true","0","OK")>
			 <cfreturn message>
			 <CFELSE>
				<cfif DSNOperation EQ "update">
					<!---check ReturnError value--->
					<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
						<cfcase value="YES">
						 <cfset message=SetXMLResponse("false","2","Unable to update DSN, verify failed.","Operation=MS SQL DSN update,DatasourceName=#name#")>
						</cfcase>
						<cfdefaultcase>
							<cfset message=SetXMLResponse("true","0","OK")>
						</cfdefaultcase>
					</cfswitch>
			 		
					<cfreturn message>
				<cfelse>
					<cfswitch expression="#ucase(DeleteOnError)#">
						<cfcase value="NO">
							<cfset message=SetXMLResponse("true","0","OK")>
							<cfreturn message>
						</cfcase>
						<cfdefaultcase>
							<cfset deletemsg=deleteDSN(adminpassword,name)>
							<cfset message=SetXMLResponse("false","2","Datasource could not be validated, please verify details.","Operation=MS SQL DSN add,DatasourceName=#name#")>
							<cfreturn message>
						</cfdefaultcase>
					</cfswitch>
				</cfif>
			</CFIF>
		<CFELSE>
		 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		 <cfreturn message>
		</CFIF>
	<cfelse>
		 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		 <cfreturn message>
	</CFIF>
	<cfcatch>
		<cfreturn debugger(error=cfcatch)>

	</cfcatch>
	</cftry>
	
	</cffunction>	
	
	<!---insert mysql datasource--->
	<cffunction name="setMySQL" access="remote" returntype="String" hint="Creates or modifies a MySQL 3.x data source.">
		<!---all the arguments for MS SQL DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="port" required="no" type="string" default="3306" hint="port number of mysql database">
	<cfargument name="database" required="yes" type="string" hint="Database name that corresponds to the data source.">
	<cfargument name="username" required="no" default="" type="string" hint=" Database username">
	<cfargument name="password" required="no" default="" type="string" hint=" Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="MySQL" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setMySQL">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK","Operation=MySQL Datasource update,DatasourceName=#name#")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnErrorOnUpdate value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK","Operation=MySQL Datasource update,DatasourceName=#name#")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info","Operation=MySQL DSN add,DatasourceName=#name#")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert Oracle datasource--->
	<cffunction name="setOracle" access="remote" returntype="String" hint="Creates or modifies a MySQL 3.x data source.">
		<!---all the arguments for Oracle DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="sid" required="yes" type="string" hint="The Oracle System Identifier that refers to the instance of the Oracle database software running on the server. ORCL is the default.">
	<cfargument name="host" required="Yes" type="string" hint="Database server host name or IP address. ">
	<cfargument name="port" required="no" type="string" default="1521" hint="Port that is used to access the database server. (default 1521)">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="oracle" type="string" hint="Always Oracle. ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="Oracle" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setOracle">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	
	<!---insert/set DB2 datasource--->
	<cffunction name="setDB2" access="remote" returntype="String" hint="Creates or modifies a DB2 data source. Refer to the ColdFusion documentation or ColdFusion MX Administrator online Help for a list of supported DB2 versions.">
		<!---all the arguments for DB2 DSN--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="port" required="no" type="string" default="50000" hint="Port used to access the database server. The default is 50000.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="db2" type="string" hint="Always DB2. ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="DB2" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="initargs" required="no" default="" type="string" hint="Initialization connection string arguments, formatted (arg1=arg1value;arg2=arg2value).  ">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
<cfset structdelete(arguments,"DeleteOnError")>
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setDB2">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
		 		<cfset message=SetXMLResponse("false","2","invalid input info")>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>

				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set Sybase datasource--->
	<cffunction name="setSybase" access="remote" returntype="String" hint="Creates or modifies a Sybase data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="port" required="no" type="string" default="5000" hint="Port used to access the database server. The default is 5000.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="vendor" required="no" default="sybase" type="string" hint="Always sybase. ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="sybase" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="selectmethod" required="no" default="direct" type="string" hint=" Select Method (direct or cursor). ">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setSybase">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set Informix datasource--->
	<cffunction name="setInformix" access="remote" returntype="String" hint="Creates or modifies an Informix data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="host" required="yes" type="string" hint="Database server host name or IP address">
	<cfargument name="InformixServer" required="yes" type="string" hint="Name of the Informix server that corresponds to the data source.">
	<cfargument name="port" required="no" type="string" default="1526" hint="Port used to access the database server. The default is 1526.">
	<cfargument name="database" required="yes" type="string" hint="Name of database on the server.">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
		<cfargument name="vendor" required="no" default="informix" type="string" hint="Always sybase. ">
	<cfargument name="type" required="no" default="ddtek" type="string" hint="Always ddtek. ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="informix" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>
	
	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setInformix">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---insert/set ODBC datasource--->
	<cffunction name="setODBCSocket" access="remote" returntype="String" hint=" Creates or modifies an ODBC socket data source.">
		<!---all the arguments for Sybase--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="useTrustedConnection" required="no" type="string" hint="If selected, causes ODBC driver to use the credentials specified in the ODBC connection or the network login id. ">
	<cfargument name="datasource" required="yes" type="string" hint="name of ODBC datasource, defined in the server control panel. ">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="no" default="" type="string" hint="A description for this data source connection. ">
	<cfargument name="port" required="no" default="19996" type="string" hint="Port that is used to access the database server. (default 19996)  ">
	<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="driver" required="no" default="ODBCSocket" type="string" hint="JDBC driver">
	<cfargument name="class" required="no" default="macromedia.jdbc.MacromediaDriver" type="string" hint="JDBC class file. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="host" required="no" default="true" type="any" hint="Database server host name or IP address.">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="TimeStampAsString" required="no" default="no" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>

	

	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setODBCSocket">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
			<cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>
				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
		<!---insert/set other datasource--->
	<cffunction name="setOther" access="remote" returntype="String" hint="Creates or modifies a user-defined data source">
		<!---all the arguments for Other--->
	<cfargument name="adminpassword" required="Yes" type="string">
	<cfargument name="name" required="yes" type="string" hint="ColdFusion datasource name.">
	<cfargument name="url" required="Yes" type="string" hint="The JDBC Connection URL for this data source.">
	<cfargument name="class" required="yes" type="string" hint="JDBC class file.">
	<cfargument name="driver" required="no" type="string" hint="JDBC driver">
	<cfargument name="username" required="no" default="" type="string" hint="Database username">
	<cfargument name="password" required="no" default="" type="string" hint="Database password">
	<cfargument name="description" required="Yes" default="cursor" type="string" hint="A description for this data source connection. ">
	<cfargument name="selectmethod" required="no" default="" type="string" hint="Select Method (direct or cursor). ">
	<cfargument name="port" required="no" default="1433" type="string" hint="Port that is used to access the database server. (default 1433)  ">
		<cfargument name="originaldsn" required="no" default="" type="string" hint="Original ColdFusion datasource name, if you are renaming this dsn. ">
	<cfargument name="encryptpassword" required="no" default="true" type="any" hint="only Bolean value allowed.Indicates whether to encrypt the password when storing it in the neo-query.xml file:">
	<cfargument name="args" required="no" default="" type="string" hint="Connection string arguments, formatted (arg1=argvalue;arg2=argvalue). ">
	<cfargument name="timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of minutes that ColdFusion maintains an unused connection before destroying it.">
	<cfargument name="MaxPooledStatements" required="no" default="" type="any" hint="only numeric value allowed. The maximum number of pooled statements. ">
	<cfargument name="interval" required="no" default="" type="any" hint="only numeric value allowed.The time (in minutes) that the server waits between cycles to check for expired data source connections to close.">
	<cfargument name="login_timeout" required="no" default="" type="any" hint="only numeric value allowed.The number of seconds before ColdFusion times out the data source connection login attempt. ">
	<cfargument name="buffer" required="no" default="" type="any" hint="only numeric value allowed.The default buffer size, used if disable_clob is not specified or True. Default is 64000 bytes. ">
	<cfargument name="blob_buffer" required="no" default="" type="any" hint="only numeric value allowed.T The default buffer size, used if disable_blob is not specified or True. Default is 64000 bytes">
	<cfargument name="enablemaxconnections" required="no" default="true" type="any" hint="only Bolean value allowed. Enables the maxconnections setting.">
	<cfargument name="maxconnections" required="no" default="" type="any" hint="only numeric value allowed.Limit connections to this maximum amount. ">
	<cfargument name="pooling" required="no" type="any" default="false" hint="Boolean value only">
	<cfargument name="disable" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_clob" required="no" type="any" hint="Boolean value only">
	<cfargument name="disable_blob" required="no" type="any" hint="Boolean value only">
	<cfargument name="select" required="no" type="any" hint="Boolean value only">
	<cfargument name="create" required="no" type="any" hint="Boolean value only">
	<cfargument name="grant" required="no" type="any" hint="Boolean value only">
	<cfargument name="insert" required="no" type="any" hint="Boolean value only">
	<cfargument name="drop" required="no" type="any" hint="Boolean value only">
	<cfargument name="revoke" required="no" type="any" hint="Boolean value only">
	<cfargument name="update" required="no" type="any" hint="Boolean value only">
	<cfargument name="alter" required="no" type="any" hint="Boolean value only">
	<cfargument name="storedproc" required="no" type="any" hint="Boolean value only">
	<cfargument name="delete" required="no" type="any" hint="Boolean value only">
	<cfargument name="DeleteOnError" required="no" type="string" default="Yes" hint="When insert new DSN,if error occur, Yes(default) to delete the DSN, No to add this DSN anyway">
	<cfargument name="ReturnErrorOnUpdate" required="no" type="string" default="Yes" hint="When update DSN, Yes(default) to return error, no for return success message in any situation">
	<!---custom arguments which is not avaliable in the cf7 server's api--->
	<cfset structdelete(arguments,"ReturnErrorOnUpdate")>
	<cfset structdelete(arguments,"DeleteOnError")>	
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
		<!---check if DSN already exist--->
	<cfset DSNList=getDSN(adminpassword,"*")>
	<cfif listfindnocase(DSNList,name) EQ 0>
		<cfset DSNOperation="add">
	<cfelse>
		<cfset DSNOperation="update">
	</cfif>

	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<!---pass arguments to cf7 admin API--->
	
	<cfinvoke component="#datasource#" method="setOther">
		<cfloop collection="#arguments#" item="key">
			<cfif evaluate("arguments."&key) NEQ "">
			<cfinvokeargument name="#key#" value="#evaluate('arguments.'&key)#">
			</cfif>
		</cfloop>
	</CFINVOKE>
	<!---verify DSN--->
	<CFINVOKE component="#datasource#" method="verifyDsn" returnvariable="VerifyDsn">
		<CFINVOKEARGUMENT name="dsn" value="#name#">
	</CFINVOKE>
	<!---pass back whether the update is successful--->
		<CFIF VerifyDsn EQ "YES">
		<!---if the DSN pass the verify, output the DSN detail as a structure--->
		 <cfset message=SetXMLResponse("true","0","OK")>
		 <cfreturn message>
		 <CFELSE>
			<cfif DSNOperation EQ "update">
<!---check ReturnError value--->
				<cfswitch expression="#ucase(ReturnErrorOnUpdate)#">
					<cfcase value="YES">
					 <cfset message=SetXMLResponse("false","2","invalid input info","Operation=MS SQL DSN update,DatasourceName=#name#")>
					</cfcase>
					<cfdefaultcase>
						<cfset message=SetXMLResponse("true","0","OK")>
					</cfdefaultcase>
				</cfswitch>				<cfreturn message>
			<cfelse>
				<cfswitch expression="#ucase(DeleteOnError)#">
					<cfcase value="NO">
						<cfset message=SetXMLResponse("true","0","OK")>
						<cfreturn message>
					</cfcase>
					<cfdefaultcase>
						<cfset deletemsg=deleteDSN(adminpassword,name)>
						<cfset message=SetXMLResponse("false","2","invalid input info")>
						<cfreturn message>
					</cfdefaultcase>
				</cfswitch>
				
			</cfif>
		</CFIF>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	

	<!---install odbc--->
	<cffunction name="installOdbcService" access="remote" returntype="String" hint=" Installs ODBC service.">
	<cfargument name="adminPassword" type="string" required="yes">
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<cfset installresult=datasource.installOdbcService()>
	<cfset message=SetXMLResponse("true","0","OK")>
	<cfreturn message>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	

	<!---remove odbc service--->
	<cffunction name="removeOdbcServic" access="remote" returntype="String" hint="Remove ODBC service.">
	<cfargument name="adminPassword" type="string" required="yes">
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<cfset installresult=datasource.removeOdbcServic()>
	<cfset message=SetXMLResponse("true","0","OK")>
	<cfreturn message>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	
	
	<!---startOdbcService--->
	<cffunction name="startOdbcService" access="remote" returntype="String" hint="start Odbc Service.">
	<cfargument name="adminPassword" type="string" required="yes">
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<cfset installresult=datasource.startOdbcService()>
	<cfset message=SetXMLResponse("true","0","OK")>
	<cfreturn message>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	

	<!---stopOdbcService--->
	<cffunction name="stopOdbcService" access="remote" returntype="String" hint="stop Odbc Service.">
	<cfargument name="adminPassword" type="string" required="yes">
	<cfif checkIP()>
	<CFIF adminLogin(adminPassword)>
	<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
	<cfset installresult=datasource.stopOdbcService()>
	<cfset message=SetXMLResponse("true","0","OK")>
	<cfreturn message>
	<CFELSE>
	 <cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 <cfreturn message>
	</CFIF>
	<cfelse>
	 <cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 <cfreturn message>
	</CFIF>
	</cffunction>	


	<!---function for delete dsn--->
	<cffunction name="deleteDSN" access="remote" returntype="string" hint="delete datasource in coldfusion">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="name" required="Yes" type="any" hint="Specifies the coldfusion datasource name which you want to delete">
		<cfset arguments.dsnname=trim(arguments.name)>
		<cfset structdelete(arguments,"name")>
		<cfset dsnname=arguments.dsnname>
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfset DSNlist=getDSN(adminpassword,"*")>
		<cfif listfindnocase(DSNlist,arguments.dsnname) NEQ 0>
		<CFOBJECT component="cfide.adminapi.datasource" name="datasource">
		<!---pass arguments to cf7 admin API--->
		<cfinvoke component="#datasource#" method="deleteDatasource">
			<cfinvokeargument name="dsnname" value="#arguments.dsnname#">
		</cfinvoke>
		<cfset message=SetXMLResponse("true","0","OK")>
	 	<cfreturn message>
		<cfelse>
		<cfset message=setXMLResponse("false","2","DSN doesn't exist")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
	 	<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 		<cfreturn message>
		</CFIF>
	</cffunction>

</cfcomponent>
