<!---developed by zhou yu 2006 and Russ Michaels--->
<!---V5--->
<!---new option for insert DSN, delete/insert on error occur--->
<!---error will be log to AdminAPI log file--->
<!---better error tracking--->
<CFCOMPONENT displayname="Adminapi" hint="Developed by Russ Michaels" extends="cfide.adminapi.webService.cf7mapping">
	<!---enable session scope--->
	<cfapplication sessionmanagement="Yes">
	
<!---for easier access, this function will return the metadata for a function--->
	<cffunction name="getFunctionMetaData" access="remote" returntype="string" hint="this method will return the metadata of a function in a WDDX packet.">
	<cfargument name="functionName" required="yes" type="string">
		<cfobject name="cf8api" component="cf8adminapi">
		<cfloop from="1" to="#arraylen(getMetadata(cf8api).functions)#" index="i">
			<cfif getMetadata(cf8api).functions[i].name EQ arguments.functionName>
				<cfset result=getMetadata(cf8api).functions[i]>
				<cfbreak>
			<cfelse>
				<cfloop from="1" to="#arraylen(getMetadata(cf8api).extends.functions)#" index="i">
				<cfif getMetadata(cf8api).extends.functions[i].name EQ arguments.functionName>
				<cfset result=getMetadata(cf8api).extends.functions[i]>
				<cfbreak>
				<cfelse>
					<cfloop from="1" to="#arraylen(getMetadata(cf8api).extends.extends.functions)#" index="i">
					<cfif getMetadata(cf8api).extends.extends.functions[i].name EQ arguments.functionName>
					<cfset result=getMetadata(cf8api).extends.extends.functions[i]>
					<cfbreak>
					<cfelse>
					  <cfloop from="1" to="#arraylen(getMetadata(cf8api).extends.extends.extends.functions)#" index="i">
						<cfif getMetadata(cf8api).extends.extends.extends.functions[i].name EQ arguments.functionName>
						<cfset result=getMetadata(cf8api).extends.extends.extends.functions[i]>
						<cfbreak>
						<!--- <cfelse>
							<cfloop from="1" to="#arraylen(getMetadata(cf8api).extends.extends.extends.extends.functions)#" index="i">
								<cfif getMetadata(cf8api).extends.extends.extends.extends.functions[i].name EQ arguments.functionName>
								<cfset result=getMetadata(cf8api).extends.extends.extends.extends.functions[i]>
								<cfbreak>
								</cfif>
							</cfloop> --->
						</cfif>
					  </cfloop>
					</cfif>
					</cfloop>
				</cfif>	
				</cfloop>
				
			</cfif>
		</cfloop>
		<cfwddx action="cfml2wddx" input="#result#" output="WDDXpacket">
	<cfreturn WDDXpacket>	
</cffunction>

	<!---check the user ip again the ip list in the ip.cfm file--->
	<cffunction name="checkIP" access="public" returntype="boolean">
	<cfargument name="clientIP" default="#cgi.REMOTE_ADDR#" required="no">

		<cfset iplist = loadconfig().iplist.xmlText>
		
		<cfif arguments.clientIP NEQ "">
			<cfif listfindnocase(iplist,arguments.clientIP) NEQ 0>
				<cfset ipok="Yes">
			<cfelse>
				<cfset ipok="No">
			</cfif>
		<cfelse>
			<cfset ipok="No">
		</cfif>
		<cfreturn ipok>
	
	
	</cffunction>
	<cffunction name="SetXMLResponse" access="public" returntype="string" output="false">
		<cfargument name="Result" type="string" required="no" default="">
		<cfargument name="ResultCode" type="string" required="no" default="">
		<cfargument name="Message" type="string" required="no" default="">
		<cfargument name="ResultData" type="string" required="no" default="">
		 
		<cfxml variable="xmlResponse"><Response xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://tempuri.org/"><cfoutput><cfif arguments.result NEQ ""><Result>#arguments.result#</Result><cfelse><Result/></cfif><cfif arguments.ResultCode NEQ ""><ResultCode>#arguments.ResultCode#</ResultCode><cfelse><ResultCode/></cfif><cfif arguments.Message NEQ ""><Message>#arguments.Message#</Message><cfelse><Message/></cfif>
		<cfif arguments.ResultData NEQ ""><ResultData>#arguments.ResultData#</ResultData><cfelse><ResultData/></cfif></cfoutput></Response></cfxml>
		<!---log the error/success message to  AdminAPI log file--->
		<cflog text="XML response as following:#toString(xmlResponse)#" file="AdminAPI" application="yes">
		<cfreturn toString(xmlResponse)>
	</cffunction>

	<cffunction name="XMLtoWDDX" access="public" returntype="string" output="false" hint="transfer xml to wddx">
		<cfargument name="XmlResponse" required="yes" type="string">
		
		<cfset leftpos=find("<wddxPacket version=",arguments.XmlResponse)>
		<cfset rightPos=find("</wddxPacket>",arguments.XmlResponse)>
		<cfset wddx=mid(arguments.XmlResponse,leftpos,rightpos-leftpos+13)>
		<cfreturn wddx>
	</cffunction>
<!---------------------end of share methods for cf6,7------------------------------->	
	
	


	<!--------------for cf7------------------->
	<!---adminstrator login function--->
	<cffunction name="adminLogin" access="private" returntype="boolean">
	<!---pass in the adminpassword--->
	<cfargument name="login" required="Yes"/>
	<CFSET cfAdmin=createObject("component", "cfide.adminapi.administrator") />
	<CFSET isLoggedIn=cfAdmin.login("#login#") />
	<cfreturn isLoggedIn />
	</cffunction>
	

	<cffunction name="debugger" access="private">

	<cfset debug = loadConfig().debug>
	<cfif debug is "true">
		<cfsavecontent variable="log">
		<hr>
		DEBUG: <cfoutput>#dateformat(now(),'dddd dd mmm yyyy')# #timeformat(now(), 'hh:mm tt')#</cfoutput>
		<hr>
		<cfif isdefined('form')>
			<cfdump var="#form#" label="form scope">
		</cfif>
		<cfif isdefined('url')>
			<cfdump var="#url#" label="URL scope">
		</cfif>
		<cfloop collection="#arguments#" item="x">
			<cfdump var="#arguments[x]#" label="#x#">
		</cfloop>
		</cfsavecontent>
		<cfset dtstamp = Dateformat(now(),'yyyymmdd')>
		<cfset logfile = '#expandpath('./')#logs/debuglog_#dtstamp#.html'>
		<cfif fileExists(logfile)>
		<cffile action="APPEND" file="#logfile#" output="#log#" addnewline="Yes" fixnewline="No">
		<cfelse>
		<cffile action="WRITE" file="#logfile#" output="#log#" addnewline="Yes" fixnewline="No">
		</cfif>
	</cfif>
	<cfif structkeyexists(arguments,"error")>
		<cfset message=SetXMLResponse("false","2","An error occured in the CFADMINAPI. The Error was:- #arguments.error.message#","")>
		<cfsavecontent variable="responseXml"><cfoutput>#message#</cfoutput></cfsavecontent>
		<cfreturn responseXML>
	</cfif>
	</cffunction>

	<cffunction name="loadConfig" access="public">
		<cfxml variable="config">
			<cfoutput><cfinclude template="config.cfm"></cfoutput>
		</cfxml>
		<cfreturn config.root>
	</cffunction>

	
</CFCOMPONENT>