<cfcomponent displayname="cf6Sandbox">
<cfscript>
		factory = createObject("java", "coldfusion.server.ServiceFactory");
		security = factory.getSecurityService();
</cfscript>

	
<!---sandbox functions--->
	<!---get any sandbox information function--->
	<CFFUNCTION access="remote" name="getSecuritySandboxes" returntype="string" hint="get a detail of a directory sandboxes. The returned detail is in a XML string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="No" type="string" hint="use * to return a list of existing sandbox directories">
		
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			
			<cfset sandboxes=security.contexts['/']>
			<cfif directory EQ "*">
			<cfset allsandboxes=StructKeyList(sandboxes)>
			<cfset message=SetXMLResponse("true","0","OK","#AllSandboxes#")>
			<cfreturn message>
			<cfelse>
			<cftry>
			
			<cfwddx input="#sandboxes[arguments.directory]#" action="cfml2wddx" output="NewPacket">
			<cfset message=SetXMLResponse("true","0","OK","#NewPacket#")>
			<cfreturn message>
			<cfcatch type="any">
			<cfset message=SetXMLResponse("false","2","This sandbox can't be found")>
			<cfreturn message>
			</cfcatch>	
			</cftry>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			<cfreturn message>
		</CFIF>
	</cffunction>	
	
	
			<!---delete sandbox--->
	<CFFUNCTION access="remote" name="deleteSecuritySandbox" returntype="string" hint="delete sandbox by specifying the directory">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<CFINVOKE component="#securityObj#" method="deleteSandbox">
			<cfinvokeargument name="webapp" value="/">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
				<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
				<cfreturn message>
		</CFIF>
	</cffunction>
			<!---enable sandbox security--->
	<CFFUNCTION access="remote" name="setEnableSandboxSecurity" returntype="string" hint="enable/disable sandbox security">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="enable" type="boolean" required="Yes" hint="Set yes to enable sandbox security, or no to disable it">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<CFINVOKE component="#securityObj#" method="setSanboxEnabled">
			<cfinvokeargument name="enable" value="#enable#">
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK","<Status>#enable#</Status>")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			<cfreturn message>
		</CFIF>
	</cffunction>

	
			<!---create default sandbox --->
	<CFFUNCTION access="remote" name="createDefaultSandboxes" returntype="string" hint="create default sandboxes">
		<cfargument name="adminpassword" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<CFINVOKE component="#securityObj#" method="createDefaultSandboxes"/>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
				<!---get enable sandbox --->
	<CFFUNCTION access="remote" name="getEnableSandboxSecurity" returntype="any" hint="check if the server's sandbox security is enable">
		<cfargument name="adminpassword" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<CFINVOKE component="#securityObj#" method="isSanboxEnabled" returnvariable="enalbeSandbox"/>
			<cfif enalbeSandbox>
			<cfset message =SetXMLResponse("true","0","Your sandbox security is ON")>
			<cfelse>
			<cfset message = SetXMLResponse("true","0","Your sandbox security is OFF")>
			</cfif>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	<!---set a sandbox with default settings--->
	<CFFUNCTION access="remote" name="setSecuritySandbox" returntype="any" hint="create a new sandbox security for the specified directory with default settings ">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfset directory=trim(directory)>
		<!---cfargument name="sandbox" type="string" required="no" hint="this has to be a WDDX packet which can be transfered back to an coldfusion array of structure"--->
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<!--- transfer sandbox WDDX packet into array of structure which is required by setSecuirySandbox
			asp.net can create array of structure, however it is not recognised by coldfusion, therefore i 
			use wddx packet to get around this
		--->
		<!---cfwddx action="wddx2cfml" input="#sandbox#" output="sandboxs"--->
		
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
		<cftry>
			<CFINVOKE component="#securityObj#" method="createNewDefaultSecurityContext" returnvariable="Sandbox">
			<cfinvokeargument name="webapp" value="/">
			<cfinvokeargument name="directory" value="#directory#">
			<!---cfinvokeargument name="sandbox" value="#sandboxs#"--->
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","Action=addSandbox, Status=OK, directory=#directory#")>
			<cfreturn message>	
			<cfcatch type="any">
			<cfset message=SetXMLResponse("false","2","Action=addSandbox, Status=Fail, directory=#directory#, Error=invalid directory")>
		    <cfreturn message>
		</cfcatch>
		</cftry>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
<!---set sandbox disabled CFFunctions--->
	<!---get Disabled CFFunctions--->
	<CFFUNCTION access="remote" name="getDisabledCFFunctions" returntype="string" hint="return a list of disabled CFFunctions of a sandbox in the format of wddx">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!----get a list of enabled cf functions--->
			<CFINVOKE method="getSecuredCFFunctions" returnvariable="result">
				<cfinvokeargument name="webapp" value="/">
				<cfinvokeargument name="directory" value="#arguments.directory#">
			</cfinvoke> 
			<cfif trim(result[1]) EQ "*">
			<cfwddx input="No disabled function" output="resultstring" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultstring#")>
			 <cfreturn message>
			<cfelse>
			<!----get a list of securable cf functions--->
			<CFINVOKE method="getSecurableCFFunctions" returnvariable="SecurableFunctions">
				<cfinvokeargument name="adminpassword" value="#arguments.adminpassword#">
			</cfinvoke>
			<!----remove enabled cf functions from securable cf functions, the result list is disabled cf functions---->
			<cfset resultlist=arraytolist(result)>
			<cfloop list="#resultlist#" index="i">
				<cfset listpos=listfindnocase(SecurableFunctions,i)>
				<cfif listpos>
					<cfset SecurableFunctions=listdeleteat(SecurableFunctions,listpos)>
				</cfif>
			</cfloop>
			
			<cfwddx action="cfml2wddx" input="#SecurableFunctions#" output="wddxpacket">
			<cfset message=SetXMLResponse("true","0","OK","#wddxpacket#")>
			<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	<!---get securable functions list--->
	<cffunction name="getSecurableCFFunctions" access="remote" returntype="string" hint="return a list of all the CFFunctions can be disabled in Sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<CFIF adminLogin(adminPassword)>
		<cfinvoke method="getSecurableCFFunctionsPrivate" returnvariable="aFunctions"/>
		<cfset SecurableCFFunctions=arraytolist(aFunctions)>
		<cfreturn SecurableCFFunctions>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
	</cffunction>
	
	<!---set Disabled CFFunctions--->
		<CFFUNCTION access="remote" name="setDisabledCFFunctions" returntype="string" hint=" Disable/enable CFFunctions by passing in a list of CFfuntions you want to disable">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="functionlist" required="yes" type="string" hint="a list of functions you want to disable. The CFfunction which is in the list will be disabled, cffunction which is not in the list will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating functionlist, delete empty elements in the list--->
		<cfset functionlist=replacenocase(functionlist,",,",",")>
		 <cfif trim(functionlist) EQ ",">
 			<cfset functionlist="">
		<cfelse>
		<cfloop index="i" list="#functionlist#">
		 <cfif trim(i) EQ "">
		  <cfset functionlist=listDeleteAt(functionlist,ListFindNoCase(functionlist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<cfset allDisabledFunctions=getDisabledCFFunctions(adminpassword,directory)>
			<cfwddx action="wddx2cfml" input="#XMLtoWDDX(allDisabledFunctions)#" output="allDisabledFunctions">
			<!---if disabled function list is empty, delete all disabled functions in sandbox--->
			<cfif trim(functionlist) EQ "">
				<!---if there is disabled cffunction--->
				<cfif trim(allDisabledFunctions) NEQ "No disabled function">
				<cfloop list="#allDisabledFunctions#" index="functionName">
				<!---enable all these disabled cf functions--->
				<cfinvoke component="#securityObj#" method="unSecureCFFunction">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="functionName" value="#functionName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled functions against already disabled functions--->
			<cfelse>
				<!---check the functions in the functionlist if they are securable cffunction--->
				<cfset SecurableCFFunctions=getSecurableCFFunctions(adminpassword)>
				<cfset unSecurableFunctions="">
				<cfloop index="functionName" list="#functionlist#">
					<!---delete the function name from the functionlist if it is not securablefunction--->
					<cfif ListFindNoCase(SecurableCFFunctions,trim(functionname)) EQ 0>
					  <cfset functionlist=listdeleteat(functionlist,ListFindNoCase(functionlist,functionname))>
					  <cfset unSecurableFunctions=unSecurableFunctions & functionname & " ">
					</cfif>
				</cfloop>
				
				 
				<!---add disabled functions:loop throught pass in functionlist against exist funcitonlist--->
				<cfloop list="#functionlist#" index="functionName">
				<!---if can't find the function in exist disable function list,add it--->
				 <cfif ListFindNoCase(alldisabledfunctions,trim(functionname)) EQ 0>
				 <cfinvoke component="#securityObj#" method="SecureCFFunction">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="functionName" value="#trim(functionName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				<!---delete existing disabled functions if it is not in the list--->
				
				<!---trim the spaces in list items--->
				<cfset newfunctionlist="">
				<cfloop index="functionname" list="#functionlist#">
					<cfset newfunctionlist=ListAppend(newfunctionlist,trim(functionname),",")>
				</cfloop>
				<cfset functionlist=newfunctionlist>
				
				<cfif trim(alldisabledfunctions) NEQ "No disabled function">
				<cfloop list="#alldisabledfunctions#" index="disabledFunction">
					<cfif ListFindNoCase (functionlist,disabledFunction) EQ 0>
					<cfinvoke component="#securityObj#" method="unSecureCFFunction">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="webapp" value="/">
						<cfinvokeargument name="functionName" value="#trim(disabledFunction)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled function list--->
		 	<cfif unSecurableFunctions EQ "">
			<cfset returnfunctionlist=getDisabledCFFunctions(adminpassword,directory)>
			<cfelse>
			<cfset returnfunctionlist=getDisabledCFFunctions(adminpassword,directory) & "," & "unsecurable functions : " & unSecurableFunctions>
			</cfif>
			<cfwddx input="#returnfunctionlist#" output="wddxpacket" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#wddxpacket#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	

<!-----------------------------set sandbox disabled CFTages setting------------------->
<!---get Disabled CFtags--->
	<CFFUNCTION access="remote" name="getDisabledCFTags" returntype="string" hint="return a list of already disabled CFTags in the sandbox ">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!---get the array of enabled cftags--->
			<CFINVOKE method="getSecuredCFTags" returnvariable="aEnabledTags">
				<cfinvokeargument name="webapp" value="/">
				<cfinvokeargument name="directory" value="#arguments.directory#">
			</cfinvoke> 
			
			<cfif aEnabledTags[1] EQ "*">
			<cfwddx input="No disabled Coldfusion tag" output="resultString" action="cfml2wddx">
			 <cfset message =SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset resultlist=arraytolist(aEnabledTags)>
			<!---get list of securable cftags--->
			<cfset SecurableTags=getSecurableCFTags(adminpassword)>
			<cfset SecurableTags=XMLToWDDX(SecurableTags)>
			<cfwddx input="#SecurableTags#" output="SecurableTags" action="wddx2cfml">
			<cfloop list="#resultlist#" index="i">
				<cfset tagpos=listfindnocase(SecurableTags,i)>
				<cfif tagpos>
				<cfset SecurableTags=listdeleteat(SecurableTags,tagpos)>
				</cfif>
			</cfloop>
			<cfwddx input="#SecurableTags#" output="diabledTags" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#diabledTags#")>
			<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---get securable coldfusion tag list--->
	<cffunction name="getSecurableCFTags" access="remote" returntype="string" hint="return a list of CFTags which can be disabled in sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfinvoke method="getSecurableCFTagsPrivate" returnvariable="result"/>
		<cfset result=arraytolist(result)>
		<cfwddx input="#result#" output="result" action="cfml2wddx">
		<cfset message=SetXMLResponse("true","0","OK","#result#")>
		<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set Disabled CFTags--->
		<CFFUNCTION access="remote" name="setDisabledCFTags" returntype="string" hint="Disable/enable CFTags by passing in a CFTag list which you want to delete">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="taglist" required="yes" type="string" hint="tags in this list will be disabled, otherwise will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating taglist, delete empty elements in the list--->
		<cfset taglist=replacenocase(taglist,",,",",")>
		 <cfif trim(taglist) EQ ",">
 			<cfset taglist="">
		<cfelse>
		<cfloop index="i" list="#taglist#">
		 <cfif trim(i) EQ "">
		  <cfset taglist=listDeleteAt(taglist,ListFindNoCase(taglist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.administrator.components.security" name="securityObj">
			<cfset allDisabledCFTags=getDisabledCFTags(adminpassword,directory)>
			<cfset allDisabledCFTags=XMLToWDDX(allDisabledCFTags)>
			<cfwddx input="#allDisabledCFTags#" output="allDisabledCFTags" action="wddx2cfml">
			<!---if disabled tag list is empty, delete all disabled tags in sandbox--->
			<cfif trim(taglist) EQ "">
				<!---if there is disabled cftags--->
				<cfif trim(allDisabledCFTags) NEQ "No disabled Coldfusion tag">
				<cfloop list="#allDisabledCFTags#" index="tagName">
				<cfinvoke component="#securityObj#" method="unSecureCFTag">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="tag" value="#tagName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled tags against already disabled tags--->
			<cfelse>
				<!---check the tags in the taglist if they are securable cftag--->
				<cfset SecurableCFTags=getSecurableCFTags(adminpassword)>
				<cfset SecurableCFTags=XMLToWDDX(SecurableCFTags)>
				<cfwddx input="#SecurableCFTags#" output="SecurableCFTags" action="wddx2cfml">
				<cfset unSecurabletags="">
				<cfloop index="tagName" list="#taglist#">
					<!---delete the tag name from the taglist if it is not securabletag--->
					<cfif ListFindNoCase(SecurableCFTags,trim(tagname)) EQ 0>
					  <cfset taglist=listdeleteat(taglist,ListFindNoCase(taglist,tagname))>
					  <cfset unSecurabletags=unSecurabletags & tagname & " ">
					</cfif>
				</cfloop>
				
				 
				<!---add disabled tag:loop throught pass in taglist against exist taglist--->
				<cfloop list="#taglist#" index="tagName">
				<!---if can't find the tag in exist disable tag list,add it--->
				 <cfif ListFindNoCase(allDisabledCFTags,trim(tagname)) EQ 0>
				 <cfinvoke component="#securityObj#" method="secureCFTag">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="tag" value="#trim(tagName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newtaglist="">
				<cfloop index="tagname" list="#taglist#">
					<cfset newtaglist=ListAppend(newtaglist,trim(tagname),",")>
				</cfloop>
				<cfset taglist=newtaglist>
				<!---delete existing disabled tags if it is not in the list--->
				<cfif trim(alldisabledCFtags) NEQ "No disabled Coldfusion tag">
				<cfloop list="#alldisabledCFTags#" index="disabledtag">
					<cfif ListFindNoCase (taglist,disabledtag) EQ 0>
					<cfinvoke component="#securityObj#" method="unSecureCFTag">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="webapp" value="/">
						<cfinvokeargument name="tag" value="#trim(disabledtag)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled tag list--->
			<cfset DisabledTags=getDisabledCFtags(adminpassword,directory)>
			<cfset DisabledTags=XMLToWDDX(DisabledTags)>
			<cfwddx input="#DisabledTags#" output="DisabledTags" action="wddx2cfml">
			<cfif isDefined('unSecurabletags') and unSecurabletags NEQ "">
				
			 <cfset returntaglist=DisabledTags & "," & "unsecurable tags : " & unSecurabletags>
			<cfELSE>
			<CFSET returntaglist=DisabledTags>			
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returntaglist#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
<!-------------------------------set sandbox disabled data sources---------------------->
<!---get Disabled DSNs--->
	<CFFUNCTION access="remote" name="getDisabledDatasources" returntype="string" hint="return a list of disabled datasource in the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!----get a list of enabled dsns--->
			<cfset EnabledDSNs=getAllEnabledDsns("/",directory)>
			<cfif EnabledDSNs[1] EQ "*">
			<cfwddx input="No disabled datasource" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset resultlist=arraytolist(EnabledDSNs)>
			<!----get a list of secureable DSNs--->
			<cfset SecurableDSNs=getSecurableDatasources(adminpassword)>
			<cfset SecurableDSNs=XMLtoWDDX(SecurableDSNs)>
			<cfwddx input="#SecurableDSNs#" output="SecurableDSNs" action="wddx2cfml">
			<cfloop list="#resultlist#" index="i">
				<cfset DSNpos=listfindnocase(SecurableDSNs,i)>
				<cfif DSNpos>
				<cfset SecurableDSNs=listdeleteat(SecurableDSNs,DSNpos)>
				</cfif>
			</cfloop>
			<cfwddx input="#SecurableDSNs#" output="SecurableDSNs" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#SecurableDSNs#")>
			<cfreturn message>
			</cfif>	

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---get securable dns list--->
	<cffunction name="getSecurableDatasources" access="remote" returntype="string" hint="return a list of datasource name which can be disabled in sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfset sqlexecutive = factory.getDataSourceService()>	
		<cfset DSNList=arraytolist(sqlexecutive.names)>
		<cfwddx input="#DSNList#" output="DSNList" action="cfml2wddx">
		<cfset message=SetXMLResponse("true","0","OK","#DSNList#")>
		<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set Disabled datasources--->
		<CFFUNCTION access="remote" name="setDisabledDatasources" returntype="string" hint="disable/enable datasource in the sandbox by passing in a datasource list">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="DSNList" required="yes" type="string" hint="datasource name which in this list will be disabled, otherwise will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating DSNlist, delete empty elements in the list--->
		<cfset DSNlist=replacenocase(DSNlist,",,",",")>
		 <cfif trim(DSNlist) EQ ",">
 			<cfset DSNlist="">
		<cfelse>
		<cfloop index="i" list="#DSNlist#">
		 <cfif trim(i) EQ "">
		  <cfset DSNlist=listDeleteAt(DSNlist,ListFindNoCase(DSNlist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!---get a list of disabled DSN--->
			<cfset allDisabledDSNs=getDisabledDatasources(adminpassword,directory)>
			<cfset allDisabledDSNs=XMLtoWDDX(allDisabledDSNs)>
			<cfwddx input="#allDisabledDSNs#" output="allDisabledDSNs" action="wddx2cfml">
			<!---if disabled dsn list is empty, delete all disabled dsn in sandbox--->
			<cfif trim(DSNlist) EQ "">
				<!---if there is disabled dsn--->
				<cfif trim(allDisabledDSNs) NEQ "No disabled datasource">
				<cfloop list="#allDisabledDSNs#" index="DSNName">
				<cfinvoke method="EnableDSN">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="DSN" value="#DSNName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled dsn against already disabled dsns--->
			<cfelse>
				<!---check the dsns in the dsnlist if they are securable dsn--->
				<cfset SecurableDSNs=getSecurableDatasources(adminpassword)>
				<cfset SecurableDSNs=XMLtoWDDX(SecurableDSNs)>
				<cfwddx input="#SecurableDSNs#" output="SecurableDSNs" action="wddx2cfml">
				<cfset unSecurableDSNs="">
				<cfloop index="DSNName" list="#DSNlist#">
					<!---delete the DSN name from the DSNlist if it is not securableDSN--->
					<cfif ListFindNoCase(SecurableDSNs,trim(DSNname)) EQ 0>
					  <cfset DSNlist=listdeleteat(DSNlist,ListFindNoCase(DSNlist,DSNname))>
					  <cfset unSecurableDSNs=unSecurableDSNs & DSNname & " ">
					</cfif>
				</cfloop>
				
				 
				<!---add disabled DSN:loop throught pass in DSNlist against exist DSNlist--->
				<cfloop list="#DSNlist#" index="DSNName">
				<!---if can't find the DSN in exist disable DSN list,add it--->
				 <cfif ListFindNoCase(allDisabledDSNs,trim(DSNname)) EQ 0>
				 <cfinvoke method="disableDSN">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="DSN" value="#trim(DSNName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newDSNlist="">

				<cfloop index="DSNname" list="#DSNlist#">
					<cfset newDSNlist=ListAppend(newDSNlist,trim(DSNname),",")>
				</cfloop>
				<cfset DSNlist=newDSNlist>
				<!---delete existing disabled DSNs if it is not in the list--->
				<cfif trim(alldisabledDSNs) NEQ "No disabled datasource">
				<cfloop list="#alldisabledDSNs#" index="disabledDSN">
					<cfif ListFindNoCase (DSNlist,disabledDSN) EQ 0>
					<cfinvoke method="EnableDSN">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="webapp" value="/">
						<cfinvokeargument name="DSN" value="#trim(disabledDSN)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled DSN list--->
			<cfset returnDSNlist=getDisabledDatasources(adminpassword,directory)>
			<cfset returnDSNlist=XMLtoWDDX(returnDSNlist)>
			<cfif isDefined('unSecurableDSNs') and unSecurableDSNs NEQ "">
			<cfwddx input="#returnDSNlist#" output="returnDSNlist" action="wddx2cfml">
			<cfset returnDSNlist=returnDSNlist & "," & "unknow DSN : " & unSecurableDSNs>
			<cfwddx input="#returnDSNlist#" output="returnDSNlist" action="wddx2cfml">
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returnDSNlist#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
<!-----------------------------set sandbox allowed IPs-------------------------------->
<!---get Secured IP Ports--->
	<CFFUNCTION access="remote" name="getSecuredIPPorts" returntype="string" hint="return a list of secured ip/ports">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory name">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!---get array of ipport---->
			<cfset IPPorts=getSecuredIPPortsPrivate("/",directory)>
			<cfif arraylen(IPPorts) NEQ 0>
			<cfset IPPortList="">
			<cfloop from="1" to="#arraylen(IPPorts)#" index="i">
				<cfset IPPortList=listappend(IPPortList,IPPorts[i].target)>
			</cfloop>
			<cfwddx input="#IPPortList#" action="cfml2wddx" output="IPPortList">
			<cfset message=SetXMLResponse("true","0","OK","#IPPortList#")>
			<cfreturn message>
			<cfelse>
				<cfwddx input="No secured IP/Ports" output="resultString" action="cfml2wddx">
			 	<cfset message = SetXMLResponse("false","2","#resultString#")>
				<cfreturn message>
			</cfif>

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set secured ipports--->
		<CFFUNCTION access="remote" name="setSecuredIPPorts" returntype="string" hint="add or delete secured ip/port by passing in a list of ip/port which you want to secure">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="IPPortList" required="yes" type="string" hint="Specifies ip list with port specifications of single,above,below,range (i.e 125.3.2.1:60,125.3.2.1:80-,125.3.2.1:-20, 125.3.2.1:5-10). ip/port in the list will be secured, otherwise will be deleted from the secured ip/port list. Pass in a empty space as ipportlist to delete all the secured ip/port and enable all the ip/port">
		<cfparam name="unSecurableIPPorts" default="" type="string">
		<cfparam name="deletePorts" default="" type="string">
		<cfset directory=trim(directory)>
		
		<!---formating IPPortList, delete empty elements in the list--->
		<cfset IPPortList=replacenocase(IPPortList,",,",",")>
		 	<cfif trim(IPPortList) EQ ",">
 				<cfset IPPortList="">
			<cfelse>
				<cfloop index="i" list="#IPPortList#">
		 		<cfif trim(i) EQ "">
		 		 <cfset IPPortList=listDeleteAt(IPPortList,ListFindNoCase(IPPortList,i))>
		 		</cfif>
				</cfloop>
			</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!---get all secured IPports as a list--->
			<cfset allSecuredIPPorts=getSecuredIPPorts(adminpassword,directory)>
			<cfset allSecuredIPPorts=XMLtoWDDX(allSecuredIPPorts)>
			<cfwddx input="#allSecuredIPPorts#" output="allSecuredIPPorts" action="wddx2cfml">
			
			<!---if IPPortList list is empty, delete all IPPortList in sandbox--->
			<cfif trim(IPPortList) EQ "">
				<!---if there is secured IPPort--->
				<cfif trim(allSecuredIPPorts) NEQ "No secured IP/Ports">
					<cfloop list="#allSecuredIPPorts#" index="IPPorts">
					
				 				<cfinvoke method="removeIPPort">
				    				<cfinvokeargument name="target" value="#trim(IPPorts)#">
				 					<cfinvokeargument name="webapp" value="/">
									<cfinvokeargument name="directory" value="#directory#">
								</cfinvoke>
								<cfset deletePorts=deletePorts & IPPorts & " ">
							
					</cfloop>
				</cfif>
			<cfelse>
			<!---check the port is valid--->
				<cfloop index="IPPortName" list="#IPPortlist#">
					<!---get the port number --->
					<cfset port=right(IPPortName,len(IPPortName)-find(":",IPPortName))>
					<!---delete theIPPort name from the IPPortlist if it's port is not in valid range--->
					<cfif port LT -65535 or port GT 65535>
					  <cfset IPPortlist=listdeleteat(IPPortlist,ListFindNoCase(IPPortlist,IPPortName))>
					  <cfset unSecurableIPPorts=unSecurableIPPorts & IPPortName & " ">
					</cfif>
				</cfloop>
			
			<!---set IPPort against already secured IPPort--->
				<!---add IPPort:loop throught pass in IPPortlist against exist IPPortlist--->
				<cfloop list="#IPPortlist#" index="IPPortName">
				<!---if can't find the IPPort in exist  IPPort list,add it--->
				 	<cfif ListFindNoCase(allSecuredIPPorts,trim(IPPortname)) EQ 0>
					 <!---seperate ip and port--->
					<cfset ip=left(IPPortName,find(":",IPPortName)-1)>
					<cfset port=right(IPPortName,len(IPPortName)-find(":",IPPortName))>
						<!---check if the port is This port and higher --->
						<!--- <cfif right(port,1) EQ "-"> --->
				 			<cfinvoke  method="addIPPort">
				    			<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="webapp" value="/">
							</cfinvoke>
						
				     </cfif>
				 </cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newIPPortlist="">
				<cfloop index="IPPortname" list="#IPPortlist#">
					<cfset newIPPortlist=ListAppend(newIPPortlist,trim(IPPortname),",")>
				</cfloop>
				<cfset IPPortlist=newIPPortlist>
				
				<cfif trim(allSecuredIPPorts) NEQ "No secured IP/Ports">
				<cfloop list="#allSecuredIPPorts#" index="SecuredIPPort">
					<!---delete existing IPPorts if it is not in the list--->
					<cfif ListFindNoCase (IPPortlist,SecuredIPPort) EQ 0>
			
							 <cfinvoke method="removeIPPort">
				    				<cfinvokeargument name="target" value="#trim(SecuredIPPort)#">
				 					<cfinvokeargument name="webapp" value="/">
									<cfinvokeargument name="directory" value="#directory#">
							  		<cfset deletePorts=deletePorts & SecuredIPPort & " ">
							  </cfinvoke>
								
				 	</cfif>
				 </cfloop>
				 </cfif>
			</cfif>
		<!---return current IPPort list--->
			<cfset returnIPPortlist=getSecuredIPPorts(adminpassword,directory)>
			<cfset returnIPPortlist=XMLToWDDX(returnIPPortlist)>
			<cfwddx input="#returnIPPortlist#" output="returnIPPortlist" action="wddx2cfml">
			<cfif unSecurableIPPorts NEQ "">
			<cfset returnIPPortlist=returnIPPortlist & "," & "invalid port: " & unSecurableIPPorts>
				<cfif deletePorts NEQ "">
					<cfset returnIPPortlist=returnIPPortlist & "," & "deleted IP/ports: " & deletePorts>
				</cfif>
			<cfelse>
				<cfset returnIPPortlist=returnIPPortlist>
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returnIPPortlist#")>
			<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	
<!---------------------------set sandbox securedfolders----------------------------->
<!---get Secured Folders--->
	<CFFUNCTION access="remote" name="getSecuredFolders" returntype="string" hint="return detail of all secured folders of the sandbox. the return sting is a xml string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			
			<CFINVOKE method="getAllEnabledFiles" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			<cfinvokeargument name="webapp" value="/">
			</cfinvoke>
			<cfif arraylen(result) EQ 0>
			 <cfwddx input="No secured folder" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset SecuredFolders="">
			<cfloop from="1" to="#arraylen(result)#" index="i">
				<cfset SecuredFolders=listappend(SecuredFolders,result[i].target)>
			</cfloop>
			<cfwddx input="#SecuredFolders#" action="cfml2wddx" output="SecuredFolders">
			<cfset message=SetXMLResponse("true","0","OK","#SecuredFolders#")>
			<cfreturn message>
			</cfif>	

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set secured folders--->
		<CFFUNCTION access="remote" name="setSecuredFolder" returntype="string" hint="set secured folder of the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="specifies the sandbox directory">
		<cfargument name="folder" required="Yes" type="string" hint="specifies the folder you want to secure">
		<cfargument name="fileRead" type="boolean" required="yes" hint="read permission">
		<cfargument name="fileWrite" type="boolean" required="yes" hint="write permission">
		<cfargument name="fileExecute" type="boolean" required="yes" hint="execute permission">
		<cfargument name="fileDelete" type="boolean" required="yes" hint="delete permission">
		<cfset directory=trim(directory)>
		<cfset folder=trim(folder)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>

		  <cfif DirectoryExists(folder)>
		  	<!---check if folder already existed in the secured folder list--->
			<!---if yes, delete the orignal, add the new one--->
			<cfset SecuredFolders=getSecuredFolders(adminpassword,directory)>
			<cfset SecuredFolders=XMLToWDDX(SecuredFolders)>
			<cfwddx input="#SecuredFolders#" output="SecuredFolders" action="wddx2cfml">
			<cfif SecuredFolders EQ "No secured folder">
			<cfinvoke method="addSecuredFolder">
				<cfinvokeargument name="directory" value="#directory#">
				<cfinvokeargument name="daFile" value="#folder#">
				<cfinvokeargument name="fileRead" value="#fileRead#">
				<cfinvokeargument name="fileWrite" value="#fileWrite#">
				<cfinvokeargument name="fileExecute" value="#fileExecute#">
				<cfinvokeargument name="fileDelete" value="#fileDelete#">
				<cfinvokeargument name="webapp" value="/">
			</cfinvoke>
			<cfelse>
				<cfif listfindnocase(SecuredFolders,folder) EQ 0>
				<cfinvoke method="addSecuredFolder">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="daFile" value="#folder#">
					<cfinvokeargument name="fileRead" value="#fileRead#">
					<cfinvokeargument name="fileWrite" value="#fileWrite#">
					<cfinvokeargument name="fileExecute" value="#fileExecute#">
					<cfinvokeargument name="fileDelete" value="#fileDelete#">
					<cfinvokeargument name="webapp" value="/">
				</cfinvoke>
				<cfelse>
				<cfinvoke method="removeSecuredFolder">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="webapp" value="/">
					<cfinvokeargument name="daFile" value="#folder#">
				</cfinvoke>
				<cfinvoke method="addSecuredFolder">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="daFile" value="#folder#">
					<cfinvokeargument name="fileRead" value="#fileRead#">
					<cfinvokeargument name="fileWrite" value="#fileWrite#">
					<cfinvokeargument name="fileExecute" value="#fileExecute#">
					<cfinvokeargument name="fileDelete" value="#fileDelete#">
					<cfinvokeargument name="webapp" value="/">
				</cfinvoke>
				</cfif>
				<cfset message=SetXMLResponse("true","0","OK","Operation=Secure folder, Directory=#directory#, folder=#folder#")>
				<cfreturn message>
			</cfif>
		  <cfelse>
		  	<cfset message=SetXMLResponse("false","2","Invalid folder path","Operation=Secure folder, Directory=#directory#, folder=#folder#")>
		  	<cfreturn message>
		  </cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---delete secured directory--->
	<cffunction name="deleteSecuredFolder" access="remote" returntype="string" hint="delete secured folder of the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="specifies the sandbox directory"> 
		<cfargument name="folder" required="Yes" type="string" hint="specifies the secured folder you want to delete">
		<cfset directory=trim(directory)>
		<cfset folder=trim(folder)>
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cftry>
			
			<cfinvoke method="removeSecuredFolder">
				<cfinvokeargument name="directory" value="#directory#">
				<cfinvokeargument name="daFile" value="#folder#">
				<cfinvokeargument name="webapp" value="/">
			</cfinvoke>
			<cfcatch>
				<cfset message=SetXMLResponse("false","2","Delete secure folder fail","Operation=Delete secure folder, Directory=#directory#, folder=#folder#")>
				<cfreturn message>
			</cfcatch>
			</cftry>
			<cfset message=SetXMLResponse("true","0","OK","Operation=Delete secure folder, Directory=#directory#, folder=#folder#")>
			<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!----------------------shared private functions------------------>
	<cffunction name="getSecurityContext" access="private">
	<cfargument name="webapp" required="true">
	<cfargument name="directory" required="true">
	<cfset var permissions = arrayNew(1)>
	<cfset var temp = "">
	
	<cfscript>
		//look for the default /* security context.
		if( structKeyExists( security.contexts[webapp], directory) )
		{
			permissions = security.contexts[webapp][directory];
		}else {
			permissions = createNewDefaultSecurityContext(webapp, directory);
		}
		
		//make a copy to remove any pointer relations.
		temp = duplicate(permissions);
		return temp;
	</cfscript>
</cffunction> 

<cffunction name="getTagPermissionPosition" access="private">
	<cfargument name="webapp" required="true">
	<cfargument name="directory" required="true">
	<cfset var permissions = arrayNew(1)>
	<cfset var aPos = 0>
	
	<cfscript>
		//get this security contexts permissions.
		permissions = getSecurityContext(webapp, directory);
		
			//find the all the dsn's. in the security context array.
			for ( i = 1; i LTE arrayLen(permissions); i = i + 1 )
			{
				//see if array item is secured datasource
				if(  permissions[i].class eq "coldfusion.tagext.GenericTagPermission") 
				{
					aPos = i;
				}
			}	
			
		return aPos;
	</cfscript>
</cffunction>
<cffunction name="getSecuredCFFunctions" access="private">
	<cfargument name="webapp" required="true">
	<cfargument name="directory" required="true">
	<cfset var permissions = arrayNew(1)>
	<cfset var aEnabledFunctions = arrayNew(1)>
	<cfset var i =1>
	<cfset var arrayPos = 1>
	<cfset var aDisabled = "">
	<cfset var aEnabled = arrayNew(1)>
	<cfset var aNewEnabled = arrayNew(1)>

	
	<cfscript>
		//get this security contexts permissions.
		permissions = getSecurityContext(webapp, directory);
		
		//get the filepermissions position.
		arrayPos = getFunctionPermissionPosition(webapp, directory);
		
		
		target = permissions[arrayPos].target;		
			if( target eq "*" )
			{
				//if target is just a wildcard then return that.
				aEnabledFunctions = listToArray(target);
			}else if( left(target,2) contains "*-" ){
				//if the target is a wildcard minus some functions. 
				//Then get a list of disabled tags and remove them 
				//from the all functions list.
				aDisabled = replace(target, "*-", "");
				aEnabled = getSecurableCFFunctionsPrivate();
				
					//loop over enabled, and remove disabled
					for( i=1; i lte arrayLen(aEnabled); i=i+1 )
					{
						if( not listFindNoCase(aDisabled, aEnabled[i]) )
						{
							arrayAppend(aNewEnabled, aEnabled[i]);
						}
					}
				aEnabledFunctions = aNewEnabled;

			}
	
		arraySort(aEnabledFunctions, "textnocase", "asc");
		return aEnabledFunctions;
	</cfscript>
</cffunction>
<cffunction name="getFunctionPermissionPosition" access="private">
	<cfargument name="webapp" required="true">
	<cfargument name="directory" required="true">
	<cfset var permissions = arrayNew(1)>
	<cfset var aPos = 0>
	<cfscript>
		//get this security contexts permissions.
		permissions = getSecurityContext(webapp, directory);
			//find the all the dsn's. in the security context array.
			for ( i = 1; i LTE arrayLen(permissions); i = i + 1 )
			{
				//see if array item is secured datasource
				if(  permissions[i].class eq "coldfusion.runtime.FunctionPermission") 
				{
					aPos = i;
				}
			}	
			
		return aPos;
	</cfscript>
</cffunction>

<cffunction name="getSecurableCFFunctionsPrivate" access="private">
	<!--- ::	Tags to be restricted	:: --->
	<cfset var aFunctions = arrayNew(1)>
	
	<cfscript>		
			//Functions to be restricted
			arrayAppend(aFunctions, "CreateObject");
			arrayAppend(aFunctions, "DirectoryExists");
			arrayAppend(aFunctions, "ExpandPath");
			arrayAppend(aFunctions, "FileExists");
			arrayAppend(aFunctions, "GetDirectoryFromPath");
			arrayAppend(aFunctions, "GetFileFromPath");
			arrayAppend(aFunctions, "GetProfileString");
			arrayAppend(aFunctions, "GetTempDirectory");
			arrayAppend(aFunctions, "GetTempFile");			
			arrayAppend(aFunctions, "GetTemplatePath");
			arrayAppend(aFunctions, "GetBaseTemplatePath");
			arrayAppend(aFunctions, "SetProfileString");
			
			//arrayAppend(aFunctions, "QueryNew");
			//arrayAppend(aFunctions, "QueryAddColumn");
			//arrayAppend(aFunctions, "QueryAddRow");
			//arrayAppend(aFunctions, "QuerySetCell");
			//arrayAppend(aFunctions, "CFUSION_DISABLE_DBCONNECTIONS");		

		arraySort(aFunctions, "textnocase", "asc");
		return aFunctions;
	</cfscript> 
</cffunction>
<cffunction name="getSecurableCFTagsPrivate" access="private">
	<!--- ::	Tags to be restricted	:: --->
 	<cfset var aTags = arrayNew(1)>
	<cfscript>
		//CF5 List
		arrayAppend( aTags, "CFContent");
		arrayAppend( aTags, "CFDirectory");
		arrayAppend( aTags, "CFFile");
		arrayAppend( aTags, "CFObject");
		arrayAppend( aTags, "CFRegistry");
		arrayAppend( aTags, "CFExecute");
		arrayAppend( aTags, "CFFtp");
		arrayAppend( aTags, "CFMail");
		arrayAppend( aTags, "CFLog");
	
		//New Tag restrictions
		arrayAppend( aTags, "CFCollection");
		arrayAppend( aTags, "CFCookie");
		arrayAppend( aTags, "CFHTTP");
		arrayAppend( aTags, "CFHTTPParam");
		arrayAppend( aTags, "CFIndex");
		arrayAppend( aTags, "CFLDAP");
		arrayAppend( aTags, "CFInvoke");
		arrayAppend( aTags, "CFSchedule");
		arrayAppend( aTags, "CFSearch");
		arrayAppend( aTags, "CFTransaction");
		
		arrayAppend( aTags, "CFQuery");
		arrayAppend( aTags, "CFInsert");
		arrayAppend( aTags, "CFUpdate");
		arrayAppend( aTags, "CFStoredProc");
		arrayAppend( aTags, "CFGridUpdate");
		
		arrayAppend( aTags, "CFObjectCache");
		arraySort(aTags, "textnocase", "asc");
		return aTags;
	</cfscript>
</cffunction>
<cffunction name="getSecuredCFTags" access="private">
	<cfargument name="webapp" required="true">
	<cfargument name="directory" required="true">
	<cfset var permissions = arrayNew(1)>
	<cfset var aEnabledTags = arrayNew(1)>
	<cfset var aDisabled = arrayNew(1)>
	<cfset var aEnabled = arrayNew(1)>
	<cfset var aNewEnabled = arrayNew(1)>

	<cfscript>		
		//get this security contexts permissions.
		permissions = getSecurityContext(webapp, directory);

			//get the filepermissions position.
			arrayPos = getTagPermissionPosition(webapp, directory);
			
			
			target = permissions[arrayPos].target;		
				if( target eq "*" )
				{
					//if target is just a wildcard then return that.
					aEnabledTags = listToArray(target);
				}else if( left(target,2) contains "*-" ){
					//if the target is a wildcard minus some functions. 
					//Then get a list of disabled tags and remove them 
					//from the all functions list.
					aDisabled = removeChars(target, 1, 2);
					aEnabled = getSecurableCFTagsPrivate();
					
						//loop over enabled, and remove disabled
						for( i=1; i lte arrayLen(aEnabled); i=i+1 )
						{
							if( not listFindNoCase(aDisabled, aEnabled[i]) )
							{
								arrayAppend(aNewEnabled, aEnabled[i]);
							}
						}
					aEnabledTags = aNewEnabled;
	
				}
		
		
		arraySort(aEnabledTags, "textnocase", "asc");
		return aEnabledTags;
	</cfscript>
</cffunction>

<cffunction name="getAllEnabledDsns" access="public">
	<cfargument name="webapp" required="yes">
	<cfargument name="directory" required="yes">
	<cfscript>
		
		var permissions = arrayNew(1);
		var aDSNs = arrayNew(1);
		var i = 1;
		
	//get all dsn already assigned to this security context
		//get this security contexts permissions.
		if(	IsDefined("security.contexts") )
		{
			if( IsStruct(security.contexts) )
			{			
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}

		
		for ( i = 1; i LTE arrayLen(permissions); i = i + 1 )
		{
			//see if array item is secured datasource
			if(  permissions[i].class eq "coldfusion.sql.DataSourcePermission") 
			{
				//make sure it's only mention once.
				if( not listFindNoCase( arrayToList(aDSNs), permissions[i].target ) )
				{
					arrayAppend(aDSNs, permissions[i].target );
				}
			}			
		}	
		
		arraySort(aDSNs, "textnocase", "asc");
</cfscript>
	<cfreturn aDSNs>
</cffunction>
 <cffunction name="EnableDSN" access="private">
	<cfargument name="dsn" required="yes">
	<cfargument name="webapp" required="yes">
	<cfargument name="directory" required="yes">
<cfscript>

	
		var permissions = arrayNew(1);
		
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}else{
			//todo: throw error here. problem accessing the security service
		}		
	
		//add dsn's to permissions array
			permission = StructNew();
			permission.class = "coldfusion.sql.DataSourcePermission";
			permission.target = dsn;
			permission.action = "";
			ArrayAppend(permissions, permission);


		//save new permissions array
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}else{
			//todo: throw error here. problem accessing the security service
		}	
		
		return permissions;		
	
	</cfscript>
	<cfreturn permissions>
</cffunction> 
<cffunction name="disableDSN" access="private">
<cfargument name="dsn" required="yes">
	<cfargument name="webapp" required="yes">
	<cfargument name="directory" required="yes">
<cfscript>

	
		var permissions = arrayNew(1);
		var aPos = "";
		var i =1;
		
			

		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}else{
			//todo: throw error here. problem accessing the security service
		}	
		
			//find the passed in dsn. in the security context array.
			for ( i = 1; i LTE arrayLen(permissions); i = i + 1 )
			{
				//see if array item is secured datasource
				if(  permissions[i].class eq "coldfusion.sql.DataSourcePermission") 
				{
					//make sure it's only mention once.
					//todo: merge into one if statement, once and/or if() bug fixed.
					if( permissions[i].target eq dsn )
					{					
						aPos = listAppend(aPos, i);
					}else if( permissions[i].target eq "*"  )
					{
						aPos = listAppend(aPos, i);
					}
				}			
			}	
			
			
			//sort list desc. so we remove the elements from the back. That way the array's automatic renumbering doesn't get us.
			aPos = listSort(aPos, "numeric", "desc");
			
			//loop over list and delete datasources.
			for( i=1; i lte listLen(aPos); i = i + 1 )
			{
				arrayDeleteAt( permissions, listGetAt(aPos, i) );
			}
	
	//save new permissions array
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}else{
			//todo: throw error here. problem accessing the security service
		}	
		
			

	</cfscript>
	<cfreturn permissions>
</cffunction>
<cffunction name="getSecuredIPPortsPrivate" access="private">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">
<cfscript>

		var permissions = arrayNew(1);
		var socketArray = arrayNew(1);
		var i = 1;
		
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		
		//loop over permissions array and find socketPermissions entries
		for( i=1; i lte arraylen(permissions); i = i+1 )
		{
			if( permissions[i].class eq "java.net.SocketPermission" )
			{
				arrayAppend( socketArray, permissions[i] );
			}
		}
		
		

</cfscript>
<cfreturn socketArray>
</cffunction>
<cffunction name="removeIPPort" access="private">
<cfargument name="target" required="yes">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">

<cfscript>
		var success = true;
		var permissions = arrayNew(1);
		var st = structNew();
		var i =1;	
	
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		
			//loop over and find target location and delete.
			for( i=1; i lte arrayLen(permissions); i=i+1 )
			{
				if( permissions[i].class eq "java.net.SocketPermission" )
				{
					if( permissions[i].target eq target )
					{
						arrayDeleteAt(permissions, i);
					}
				}
			}
		
		
			
		
		//save
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}		
		
		
	
</cfscript>
</cffunction>
<cffunction name="addIPPort" access="private">

<cfargument name="directory" required="yes">
<cfargument name="webapp" required="yes">
<cfargument name="ip" required="yes">
<cfargument name="port" required="yes">

<cfscript>
		var success = true;
		var permissions = arrayNew(1);
		var arrayPos = 0;
		var actionList = "connect,resolve";
		
		//create new socketPermission struct for ip, and append to the permissions array
		var st = structNew();
		var i = 1;

	
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		

			//loop over and check to see if wildcard stll exists. If it	does delete it.
			for( i=1; i lte arrayLen(permissions); i=i+1 )
			{
				if( permissions[i].class eq "java.net.SocketPermission" )
				{
					if( permissions[i].target eq "*" )
					{
						arrayDeleteAt(permissions, i);
					}
				}
			}
			

			//loop over and check to see if this combo exists, if it do's we'll update instead of insert.
			for( i=1; i lte arrayLen(permissions); i=i+1 )
			{
				if( permissions[i].class eq "java.net.SocketPermission" )
				{
					if( permissions[i].target eq "#ip#:#port#" )
					{
						arrayPos = i;
					}
					
				}
			}

			
			st.class = "java.net.SocketPermission";

			if( port eq 0 or port eq "" )
			{
				st.target = ip;
			}else{
				st.target = ip &":" & port;
			}
			st.action = actionList;
			
			//append to array.
			if( arrayPos gt 0 )
			{
				permissions[arrayPos] = st;
			}else {
				arrayAppend(permissions, st);
			}
		
		//save
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}		
		

</cfscript>

</cffunction>
<cffunction name="getAllEnabledFiles" access="private">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">
<cfscript>

		var permissions = arrayNew(1);
		var aFiles = arrayNew(1);
		var i = 1;
		
	//get all dsn already assigned to this security context
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{			
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		
		for ( i = 1; i LTE arrayLen(permissions); i = i + 1 )
		{
			//see if array item is secured datasource
			if(  permissions[i].class eq "java.io.FilePermission") 
			{
					arrayAppend(aFiles, permissions[i] );
			}			
		}	
		

		
		
</cfscript>
<cfreturn aFiles>
</cffunction>
<cffunction name="addSecuredFolder" access="private">
<cfargument name="daFile" required="yes">
<cfargument name="fileRead" required="yes">
<cfargument name="fileWrite" required="yes">
<cfargument name="fileExecute" required="yes">
<cfargument name="fileDelete" required="yes">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">
<cfscript>
		var permissions = arrayNew(1);
		var st = structNew();
		var filePos = 0;
		var act = "";
	
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		
		
			//set file permissions, pass this in as a list
			if(fileRead) 
				{act = ListAppend(act, "read", ",");}
			if(fileWrite) 
				{act = ListAppend(act, "write", ",");}
			if(fileExecute) 
				{act = ListAppend(act, "execute", ",");}
			if(fileDelete) 
				{act = ListAppend(act, "delete", ",");}

			//build struct
			st.class = "java.io.FilePermission";
			st.target = daFile;
			st.action = act;
			
				//add or edit file/dir.
					if( filePos neq 0 )
					{
						permissions[filePos] = st;
					}else{
						ArrayAppend(permissions, st);			
					}
				
			
		//save new permissions array
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}		


</cfscript>

</cffunction>
<cffunction name="removeSecuredFolder" access="private">
<cfargument name="daFile" required="yes">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">
<cfscript>

		var permissions = arrayNew(1);
		var location = "0";
	
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		//get location
		location =getFilePosition(daFile, webapp, directory);
		
		//delete file.
		if( location gt 0 )
		{
			arrayDeleteAt(permissions, location);
		}
		
		
		//save
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{
				security.contexts[webapp][directory] = permissions ;
			}
		}		

</cfscript>
</cffunction>

<cffunction name="getFilePosition" access="private">
<cfargument name="daFile" required="yes">
<cfargument name="webapp" required="yes">
<cfargument name="directory" required="yes">
<cfscript>

		var permissions = arrayNew(1);
		var i =1;
		var location = 0;
	
		//get this security contexts permissions.
		if(	IsDefined("security.contexts"))
		{
			if( IsStruct(security.contexts) )
			{		
				permissions = duplicate(security.contexts[webapp][directory]);
			}
		}
		
		//loop over array and find keys.
		for( i =1; i lte arrayLen(permissions); i = i+1 )
		{
			if( permissions[i].class eq "java.io.FilePermission" )
			{
				if( permissions[i].target eq daFile )
				{
					location = i;
				}
			}
		}
	
</cfscript>
<cfreturn location>
</cffunction>
</cfcomponent>