<cfcomponent displayname="cf6mapping" hint="developed by zhou yu in LNC" extends="cfide.adminapi.webservice.cf6Datasource">
<cfscript>
		factory = createObject("java", "coldfusion.server.ServiceFactory");
		runtime = factory.getRuntimeService();
</cfscript>




<!---mapping functions--->
	<!---get any mapping information function--->
	<CFFUNCTION name="getMappings" access="remote" returntype="string" hint="get the map path of a mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="No" type="string" hint="Specifies the map name of the mapping">
		<cfset mapName=trim(mapName)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<!--- <CFOBJECT component="cfide.adminapi.extensions" name="extensions"> --->
			<cfif mapName EQ "*">
				<!--- <CFINVOKE component="#extensions#" method="getMappings" returnvariable="mappings"/> --->
				<cfset mappings=runtime.mappings>
				<cfset mapNames=StructKeyList(mappings)>
				<cfreturn mapNames>
			<cfelse>
				<cfset message=SetXMLResponse("true","0","OK","#runtime.mappings[arguments.mapName]#")>
				<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 		<cfreturn message>
		</CFIF>
	</cffunction>	
	
	<!---set mapping--->
		<CFFUNCTION name="setMapping" access="remote" returntype="string" hint="add a new mapping or change mapping path. If the mapname already exist, update mappath, otherwise add new mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="Yes" type="string">
		<cfargument name="mapPath" required="Yes" type="string">
		<cfset mapName=trim(mapName)>
		<cfset mapPath=trim(mapPath)>

		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfif DirectoryExists(mapPath)>
				<cfif validatemapping(mapName) NEQ "">
				<cfset runtime.mappings[validatemapping(mapName)] = arguments.mapPath>
				<cfset message=SetXMLResponse("true","0","OK")>
				<cfreturn message>
				<cfelse>
				<cfset 	message=SetXMLResponse("false","2","Invalid map name")>
				<cfreturn message>
				</cfif>
			<cfelse>
				<cfset message=SetXMLResponse("false","2","Invalid map path")>
				<cfreturn message>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			 <cfreturn message>
		</CFIF>
	</cffunction>
	<cffunction name="validatemapping" access="public">
		<cfargument name="mapName" required="Yes">	
		<cfscript>
			/* Validation rules
				1: Must have something
				2: Must not have // (or ///, etc)
				3: Must begin with /
				4: Must contain only a-z0-9_- chars
				5. Must not end in /
				6. Allow _ and -
				
				New mod - mappings must begin with a /, but we auto add now to be nice.
				I kept the logic in the if below in case we decide to not be nice
				
				New mod, dont allow / at end - so I auto remove. Again, kept logic
				below in case we remove later
				
				New mod, now allow -
			*/
	
			if(left(arguments.mapname,1) is not "/") 
			{	arguments.mapname = "/" & arguments.mapname; }
			if(right(arguments.mapname,1) is "/" and arguments.mapname is not "/") 
			{	arguments.mapname = left(arguments.mapname,len(arguments.mapname)-1); }
			
		 	if(Len(Trim(arguments.mapname)) EQ 0 OR
				find("//", arguments.mapname) OR
				left(arguments.mapname, 1) is not "/" OR
				REFindNoCase("[^/a-z0-9_-]",trim(arguments.mapname))  OR
				(right(arguments.mapname, 1) is "/" and arguments.mapname is not "/")
			  )
			{ errorMessage="invalid map name";	}
		</cfscript>
		<cfif isdefined('errorMessage')>
		<cfreturn "">
		<cfelse>
		<cfreturn arguments.mapname>
		</cfif>
	</cffunction>
		<!---delete mapping--->
		<CFFUNCTION name="deleteMapping" access="remote" returntype="String" hint="delete mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<!---format mapName--->
		<cfset mapName=trim(mapName)>
		<cfif left(mapName,1) NEQ "/">
			<cfset mapName="/#mapName#">
		</cfif>
			<cfset newMapping=runtime.mappings>
			<cfset structdelete(newMapping,mapName)>	
			<cfset runtime=newMapping>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			 <cfreturn message>
		</CFIF>
	</cffunction>

</cfcomponent>