<cfcomponent displayname="cf7Sandbox" hint="manage coldfusion sandboxes">
<!---sandbox functions--->
	<!---get any sandbox information function--->
	<CFFUNCTION access="remote" name="getSecuritySandboxes" returntype="string" hint="get a detail of a directory sandboxes. The returned detail is in a XML string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="No" type="string" hint="use * to return a list of existing sandbox directories">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<cfif directory EQ "*">
				<CFINVOKE component="#security#" method="getSecuritySandboxes" returnvariable="Sandboxes"/>
				<cfset allsandboxes=StructKeyList(sandboxes)>
				<cfset message=SetXMLResponse("true","0","OK","#AllSandboxes#")>
				<cfreturn message>
			<cfelse>
				<cftry>
					<CFINVOKE component="#security#" method="getSecuritySandboxes" returnvariable="Sandbox">
					<cfinvokeargument name="directory" value="#directory#">
					</cfinvoke>
					
					<cfwddx input="#Sandbox#" action="cfml2wddx" output="NewPacket">
					<cfset message=SetXMLResponse("true","0","OK","#NewPacket#")>
					<cfreturn message>
					<cfcatch type="any">
						<cfset message=SetXMLResponse("false","2","Sandbox not found!")>
					<cfreturn message>
					</cfcatch>	
				</cftry>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			<cfreturn message>
		</CFIF>
	</cffunction>	
			<!---delete sandbox--->
	<CFFUNCTION access="remote" name="deleteSecuritySandbox" returntype="string" hint="delete sandbox by specifying the directory">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="deleteSecuritySandbox">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
				<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
				<cfreturn message>
		</CFIF>
	</cffunction>
			<!---enable sandbox security--->
	<CFFUNCTION access="remote" name="setEnableSandboxSecurity" returntype="string" hint="enable/disable sandbox security">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="enable" type="boolean" required="Yes" hint="Set yes to enable sandbox security, or no to disable it">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="setEnableSandboxSecurity">
			<cfinvokeargument name="enable" value="#enable#">
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK","<Status>#enable#</Status>")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			<cfreturn message>
		</CFIF>
	</cffunction>

	
			<!---create default sandbox --->
	<CFFUNCTION access="remote" name="createDefaultSandboxes" returntype="string" hint="create default sandboxes">
		<cfargument name="adminpassword" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="createDefaultSandboxes"/>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
				<!---get enable sandbox --->
	<CFFUNCTION access="remote" name="getEnableSandboxSecurity" returntype="any" hint="check if the server's sandbox security is enable">
		<cfargument name="adminpassword" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getEnableSandboxSecurity" returnvariable="enalbeSandbox"/>
			<cfif enalbeSandbox>
			<cfset message ="Your sandbox security is ON">
			<cfelse>
			<cfset message = "Your sandbox security is OFF">
			</cfif>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	<!---set a sandbox with default settings--->
	<CFFUNCTION access="remote" name="setSecuritySandbox" returntype="any" hint="create a new sandbox security for the specified directory with default settings ">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfset directory=trim(directory)>

		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		
			<CFOBJECT component="cfide.adminapi.security" name="security">
		<cftry>
			<CFINVOKE component="#security#" method="setSecuritySandbox" returnvariable="Sandbox">
			<cfinvokeargument name="directory" value="#directory#">

			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK","Action=addSandbox, Status=OK, directory=#directory#")>
			<cfreturn message>	
			<cfcatch type="any">
			<cfset message=SetXMLResponse("false","2","invalid directory","directory=#directory#")>
		    <cfreturn message>
		</cfcatch>
		</cftry>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			<cfreturn message>
		</CFIF>
	</cffunction>
	
<!---set sandbox disabled CFFunctions--->
	<!---get Disabled CFFunctions--->
	<CFFUNCTION access="remote" name="getDisabledCFFunctions" returntype="string" hint="return a list of disabled CFFunctions of a sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getDisabledCFFunctions" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfif arraylen(result) EQ 0>
			<cfwddx input="No disabled function" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset resultlist=arraytolist(result)>
			<cfwddx action="cfml2wddx" input="#resultlist#" output="wddxpacket">
			<cfset message=SetXMLResponse("true","0","OK","#wddxpacket#")>
			<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	<!---get securable functions list--->
	<cffunction name="getSecurableCFFunctions" access="remote" returntype="string" hint="return a list of all the CFFunctions can be disabled in Sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<CFIF adminLogin(adminPassword)>
		<cfinvoke component="cfide.adminapi.security" method="getSecurableCFFunctions" returnvariable="SecurableCFFunctions"/>
		<cfset SecurableCFFunctions=arraytolist(SecurableCFFunctions)>
		<cfreturn SecurableCFFunctions>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
	</cffunction>
	
	<!---set Disabled CFFunctions--->
		<CFFUNCTION access="remote" name="setDisabledCFFunctions" returntype="string" hint=" Disable/enable CFFunctions by passing in a list of CFfuntions you want to disable">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="functionlist" required="yes" type="string" hint="a list of functions you want to disable. The CFfunction which is in the list will be disabled, cffunction which is not in the list will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating functionlist, delete empty elements in the list--->
		<cfset functionlist=replacenocase(functionlist,",,",",")>
		 <cfif trim(functionlist) EQ ",">
 			<cfset functionlist="">
		<cfelse>
		<cfloop index="i" list="#functionlist#">
		 <cfif trim(i) EQ "">
		  <cfset functionlist=listDeleteAt(functionlist,ListFindNoCase(functionlist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfobject component="cfide.adminapi.security" name="security">
			<cfset allDisabledFunctions=getDisabledCFFunctions(adminpassword,directory)>
			<cfset allDisabledFunctions=xmltowddx(allDisabledFunctions)>
			<cfwddx input="#allDisabledFunctions#" output="allDisabledFunctions" action="wddx2cfml">
			
			<!---if disabled function list is empty, delete all disabled functions in sandbox--->
			<cfif trim(functionlist) EQ "">
				<!---if there is disabled cffunction--->
				<cfif trim(allDisabledFunctions) NEQ "No disabled function">
				<cfloop list="#allDisabledFunctions#" index="functionName">
				<cfinvoke component="#security#" method="deleteDisabledCFFunction">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="functionName" value="#functionName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled functions against already disabled functions--->
			<cfelse>
				<!---check the functions in the functionlist if they are securable cffunction--->
				<cfset SecurableCFFunctions=getSecurableCFFunctions(adminpassword)>
				<cfset unSecurableFunctions="">
				<cfloop index="functionName" list="#functionlist#">
					<!---delete the function name from the functionlist if it is not securablefunction--->
					<cfif ListFindNoCase(SecurableCFFunctions,trim(functionname)) EQ 0>
					  <cfset functionlist=listdeleteat(functionlist,ListFindNoCase(functionlist,functionname))>
					  <cfset unSecurableFunctions=unSecurableFunctions & functionname & " ">
					</cfif>
				</cfloop>
				
				 
				<!---add disabled functions:loop throught pass in functionlist against exist funcitonlist--->
				<cfloop list="#functionlist#" index="functionName">
				<!---if can't find the function in exist disable function list,add it--->
				 <cfif ListFindNoCase(alldisabledfunctions,trim(functionname)) EQ 0>
				 <cfinvoke component="#security#" method="setDisabledCFFunction">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="functionName" value="#trim(functionName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				<!---delete existing disabled functions if it is not in the list--->
				
				<!---trim the spaces in list items--->
				<cfset newfunctionlist="">
				<cfloop index="functionname" list="#functionlist#">
					<cfset newfunctionlist=ListAppend(newfunctionlist,trim(functionname),",")>
				</cfloop>
				<cfset functionlist=newfunctionlist>
				
				<cfif trim(alldisabledfunctions) NEQ "No disabled function">
				<cfloop list="#alldisabledfunctions#" index="disabledFunction">
					<cfif ListFindNoCase (functionlist,disabledFunction) EQ 0>
					<cfinvoke component="#security#" method="deleteDisabledCFFunction">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="functionName" value="#trim(disabledFunction)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled function list--->
		 	<cfif unSecurableFunctions EQ "">
			<cfset returnfunctionlist=getDisabledCFFunctions(adminpassword,directory)>
			<cfelse>
			<cfset returnfunctionlist=getDisabledCFFunctions(adminpassword,directory) & "," & "unsecurable functions : " & unSecurableFunctions>
			</cfif>
			<cfwddx input="#returnfunctionlist#" output="wddxpacket" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#wddxpacket#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
		<cfset debugger(arguments=arguments)>
	</cffunction>
	

<!---set sandbox disabled CFTages setting--->
<!---get Disabled CFtags--->
	<CFFUNCTION access="remote" name="getDisabledCFTags" returntype="string" hint="return a list of already disabled CFTags in the sandbox ">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getDisabledCFTags" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfif arraylen(result) EQ 0>
				<cfwddx input="No disabled Coldfusion tag" output="resultString" action="cfml2wddx">
			 <cfset message =SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset resultlist=arraytolist(result)>
			<cfwddx input="#resultlist#" output="resultlist" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#resultlist#")>
			<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---get securable coldfusion tag list--->
	<cffunction name="getSecurableCFTags" access="remote" returntype="string" hint="return a list of CFTags which can be disabled in sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfinvoke component="cfide.adminapi.security" method="getSecurableCFTags" returnvariable="result"/>
		<cfset result=arraytolist(result)>
		<cfwddx input="#result#"  output="result" action="cfml2wddx">
		<cfset message=SetXMLResponse("true","0","OK","#result#")>
		<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set Disabled CFTags--->
		<CFFUNCTION access="remote" name="setDisabledCFTags" returntype="string" hint="Disable/enable CFTags by passing in a CFTag list which you want to delete">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="taglist" required="yes" type="string" hint="tags in this list will be disabled, otherwise will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating taglist, delete empty elements in the list--->
		<cfset taglist=replacenocase(taglist,",,",",")>
		 <cfif trim(taglist) EQ ",">
 			<cfset taglist="">
		<cfelse>
		<cfloop index="i" list="#taglist#">
		 <cfif trim(i) EQ "">
		  <cfset taglist=listDeleteAt(taglist,ListFindNoCase(taglist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfobject component="cfide.adminapi.security" name="security">
			<cfset allDisabledCFTags=getDisabledCFTags(adminpassword,directory)>
			<cfset allDisabledCFTags=xmltowddx(allDisabledCFTags)>
			<cfwddx input="#allDisabledCFTags#" output="allDisabledCFTags" action="wddx2cfml">
			<!---if disabled tag list is empty, delete all disabled tags in sandbox--->
			<cfif trim(taglist) EQ "">
				<!---if there is disabled cftags--->
				<cfif trim(allDisabledCFTags) NEQ "No disabled Coldfusion tag">
				<cfloop list="#allDisabledCFTags#" index="tagName">
				<cfinvoke component="#security#" method="deleteDisabledCFTag">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="tag" value="#tagName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled tags against already disabled tags--->
			<cfelse>
				<!---check the tags in the taglist if they are securable cftag--->
				<cfset SecurableCFTags=getSecurableCFTags(adminpassword)>
				<cfset SecurableCFTags=XMLtoWDDX(SecurableCFTags)>
				<cfwddx input="#SecurableCFTags#" output="SecurableCFTags" action="wddx2cfml">
				<cfset unSecurabletags="">
				<cfloop index="tagName" list="#taglist#">
					<!---delete the tag name from the taglist if it is not securabletag--->
					<cfif ListFindNoCase(SecurableCFTags,trim(tagname)) EQ 0>
					  <cfset taglist=listdeleteat(taglist,ListFindNoCase(taglist,tagname))>
					  <cfset unSecurabletags=unSecurabletags & tagname & " ">
					</cfif>
				</cfloop>
				<!----if taglist become empty, delete all exist tags--->
				<cfif taglist EQ "">
					<!---if there is disabled cftags--->
					<cfif trim(allDisabledCFTags) NEQ "No disabled Coldfusion tag">
					<cfloop list="#allDisabledCFTags#" index="tagName">
						<cfinvoke component="#security#" method="deleteDisabledCFTag">
							<cfinvokeargument name="directory" value="#directory#">
							<cfinvokeargument name="tag" value="#tagName#">
						</cfinvoke>
					</cfloop>
					</cfif>
					<cfset message=SetXMLResponse("true","0","OK")>
					<cfreturn message>
					<cfabort>
				</cfif>
				 
				<!---add disabled tag:loop throught pass in taglist against exist taglist--->
				
				
				<cfloop list="#taglist#" index="tagName">
				<!---if can't find the tag in exist disable tag list,add it--->
				 <cfif ListFindNoCase(allDisabledCFTags,trim(tagname)) EQ 0>
				 <cfinvoke component="#security#" method="setDisabledCFTag">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="tag" value="#trim(tagName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newtaglist="">
				<cfloop index="tagname" list="#taglist#">
					<cfset newtaglist=ListAppend(newtaglist,trim(tagname),",")>
				</cfloop>
				<cfset taglist=newtaglist>
				<!---delete existing disabled tags if it is not in the list--->
				<cfif trim(alldisabledCFtags) NEQ "No disabled Coldfusion tag">
				<cfloop list="#alldisabledCFTags#" index="disabledtag">
					<cfif ListFindNoCase (taglist,disabledtag) EQ 0>
					<cfinvoke component="#security#" method="deleteDisabledCFtag">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="tag" value="#trim(disabledtag)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled tag list--->
			<cfif isDefined('unSecurabletags') and unSecurabletags NEQ "">
			 <cfset returntaglist=getDisabledCFtags(adminpassword,directory) & "," & "unsecurable tags : " & unSecurabletags>
			<cfELSE>
			<CFSET returntaglist=getDisabledCFtags(adminpassword,directory)>
			<cfset 	returntaglist=xmltowddx(returntaglist)>
			<cfwddx input="#returntaglist#" output="returntaglist" action="wddx2cfml">	
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returntaglist#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
<!---set sandbox disabled data sources--->
<!---get Disabled DSNs--->
	<CFFUNCTION access="remote" name="getDisabledDatasources" returntype="string" hint="return a list of disabled datasource in the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getDisabledDatasources" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfif arraylen(result) EQ 0>
			<cfwddx input="No disabled datasource" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset resultlist=arraytolist(result)>
			<cfwddx input="#resultlist#" output="resultlist" action="cfml2wddx">
			<cfset message=SetXMLResponse("true","0","OK","#resultlist#")>
			<cfreturn message>
			</cfif>	

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---get securable dns list--->
	<cffunction name="getSecurableDatasources" access="remote" returntype="string" hint="return a list of datasource name which can be disabled in sandbox">
		<cfargument name="adminpassword" required="yes" type="string">
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
		<cfinvoke component="cfide.adminapi.datasource" method="getDatasources" returnvariable="DSNs"/>
		
		<cfset DSNList=structkeylist(DSNs)>
		<cfset message=SetXMLResponse("true","0","OK","#DSNList#")>
		<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set Disabled datasources--->
		<CFFUNCTION access="remote" name="setDisabledDatasources" returntype="string" hint="disable/enable datasource in the sandbox by passing in a datasource list">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="DSNList" required="yes" type="string" hint="datasource name which in this list will be disabled, otherwise will be enabled">
		<cfset directory=trim(directory)>
		
		<!---formating DSNlist, delete empty elements in the list--->
		<cfset DSNlist=replacenocase(DSNlist,",,",",")>
		 <cfif trim(DSNlist) EQ ",">
 			<cfset DSNlist="">
		<cfelse>
		<cfloop index="i" list="#DSNlist#">
		 <cfif trim(i) EQ "">
		  <cfset DSNlist=listDeleteAt(DSNlist,ListFindNoCase(DSNlist,i))>
		 </cfif>
		</cfloop>
		</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfobject component="cfide.adminapi.security" name="security">
			<cfset allDisabledDSNs=getDisabledDatasources(adminpassword,directory)>
			<cfset allDisabledDSNs=xmltowddx(allDisabledDSNs)>
			<cfwddx input="#allDisabledDSNs#" output="allDisabledDSNs" action="wddx2cfml">
			
			<!---if disabled dsn list is empty, delete all disabled dsn in sandbox--->
			<cfif trim(DSNlist) EQ "">
				<!---if there is disabled dsn--->
				<cfif trim(allDisabledDSNs) NEQ "No disabled datasource">
				<cfloop list="#allDisabledDSNs#" index="DSNName">
				<cfinvoke component="#security#" method="deleteDisabledDatasource">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="datasource" value="#DSNName#">
				</cfinvoke>
				</cfloop>
				</cfif>
			<!---set disabled dsn against already disabled dsns--->
			<cfelse>
				<!---check the dsns in the dsnlist if they are securable dsn--->
				<cfset SecurableDSNs=getSecurableDatasources(adminpassword)>
				<cfset unSecurableDSNs="">
				<cfloop index="DSNName" list="#DSNlist#">
					<!---delete the DSN name from the DSNlist if it is not securableDSN--->
					<cfif ListFindNoCase(SecurableDSNs,trim(DSNname)) EQ 0>
					  <cfset DSNlist=listdeleteat(DSNlist,ListFindNoCase(DSNlist,DSNname))>
					  <cfset unSecurableDSNs=unSecurableDSNs & DSNname & " ">
					</cfif>
				</cfloop>
				
				 
				<!---add disabled DSN:loop throught pass in DSNlist against exist DSNlist--->
				<cfloop list="#DSNlist#" index="DSNName">
				<!---if can't find the DSN in exist disable DSN list,add it--->
				 <cfif ListFindNoCase(allDisabledDSNs,trim(DSNname)) EQ 0>
				 <cfinvoke component="#security#" method="setDisabledDatasource">
				 	<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="datasource" value="#trim(DSNName)#">
				 </cfinvoke>	
				 </cfif>
				</cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newDSNlist="">

				<cfloop index="DSNname" list="#DSNlist#">
					<cfset newDSNlist=ListAppend(newDSNlist,trim(DSNname),",")>
				</cfloop>
				<cfset DSNlist=newDSNlist>
				<!---delete existing disabled DSNs if it is not in the list--->
				<cfif trim(alldisabledDSNs) NEQ "No disabled datasource">
				<cfloop list="#alldisabledDSNs#" index="disabledDSN">
					<cfif ListFindNoCase (DSNlist,disabledDSN) EQ 0>
					<cfinvoke component="#security#" method="deleteDisabledDatasource">
				 		<cfinvokeargument name="directory" value="#directory#">
						<cfinvokeargument name="datasource" value="#trim(disabledDSN)#">
				    </cfinvoke>	
				 	</cfif>
				</cfloop>
				</cfif>
			</cfif>
		<!---return current disabled DSN list--->
			<cfset DisabledDSNs=getDisabledDatasources(adminpassword,directory)>
			<cfset DisabledDSNs=xmltowddx(DisabledDSNs)>
			<cfwddx input="#DisabledDSNs#" output="DisabledDSNs" action="wddx2cfml">
			<cfif not isDefined('unSecurableDSNs')>
			<cfset returnDSNlist=DisabledDSNs>
			<cfelseif unSecurableDSNs NEQ "">
			<cfset returnDSNlist=DisabledDSNs & "," & "unknow DSN : " & unSecurableDSNs>
			<cfelse>
			<cfset returnDSNlist=DisabledDSNs>
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returnDSNlist#")>
			<cfreturn message>
	
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
<!---set sandbox allowed IPs--->
<!---get Secured IP Ports--->
	<CFFUNCTION access="remote" name="getSecuredIPPorts" returntype="string" hint="return a list of secured ip/ports">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory name">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getSecuredIPPorts" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfif arraylen(result) EQ 0 or arraytolist(result) EQ "*">
			<cfwddx input="No secured IP/Ports" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfset result=arraytolist(result)>
			<cfwddx input="#result#" output="result" action="cfml2wddx"> 
			<cfset message=SetXMLResponse("true","0","OK","#result#")>
			<cfreturn message>
			</cfif>	

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set secured ipports--->
		<CFFUNCTION access="remote" name="setSecuredIPPorts" returntype="string" hint="add or delete secured ip/port by passing in a list of ip/port which you want to secure">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string">
		<cfargument name="IPPortList" required="yes" type="string" hint="Specifies ip list with port specifications of single,above,below,range (i.e 125.3.2.1:60,125.3.2.1:80-,125.3.2.1:-20, 125.3.2.1:5-10). ip/port in the list will be secured, otherwise will be deleted from the secured ip/port list. Pass in a empty space as ipportlist to delete all the secured ip/port and enable all the ip/port">
		<cfparam name="unSecurableIPPorts" default="" type="string">
		<cfparam name="deletePorts" default="" type="string">
		<cfset directory=trim(directory)>
		
		<!---formating IPPortList, delete empty elements in the list--->
		<cfset IPPortList=replacenocase(IPPortList,",,",",")>
		 	<cfif trim(IPPortList) EQ ",">
 				<cfset IPPortList="">
			<cfelse>
				<cfloop index="i" list="#IPPortList#">
		 		<cfif trim(i) EQ "">
		 		 <cfset IPPortList=listDeleteAt(IPPortList,ListFindNoCase(IPPortList,i))>
		 		</cfif>
				</cfloop>
			</cfif>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfobject component="cfide.adminapi.security" name="security">
			<cfset allSecuredIPPorts=getSecuredIPPorts(adminpassword,directory)>
			<cfset allSecuredIPPorts=xmltowddx(allSecuredIPPorts)>
			<cfwddx input="#allSecuredIPPorts#" output="allSecuredIPPorts" action="wddx2cfml">
			<!---if IPPortList list is empty, delete all IPPortList in sandbox--->
			<cfif trim(IPPortList) EQ "">
				<!---if there is secured IPPort--->
				<cfif trim(allSecuredIPPorts) NEQ "No secured IP/Ports">
					<cfloop list="#allSecuredIPPorts#" index="IPPorts">
						<!---seperate ip and port--->
						<cfset ip=left(IPPorts,find(":",IPPorts)-1)>
						<cfset port=right(IPPorts,len(IPPorts)-find(":",IPPorts))>
							<cfif right(port,1) EQ "-">
				 				<cfinvoke component="#security#" method="deleteSecuredIPPort">
				    				<cfinvokeargument name="directory" value="#directory#">
				 					<cfinvokeargument name="ip" value="#trim(ip)#">
									<cfinvokeargument name="port" value="#trim(port)#">
									<cfinvokeargument name="portType" value="higher">
								</cfinvoke>
								<cfset deletePorts=deletePorts & IPPorts & " ">
							<!---check if the port is The port and lower--->
							<cfelseif left(port,1) EQ "-">
								 <cfinvoke component="#security#" method="deleteSecuredIPPort">
				   					<cfinvokeargument name="directory" value="#directory#">
				 					<cfinvokeargument name="ip" value="#trim(ip)#">
									<cfinvokeargument name="port" value="#trim(port)#">
								 	<cfinvokeargument name="portType" value="lower">
				 				</cfinvoke>
								<cfset deletePorts=deletePorts & IPPorts & " ">
							 <!---check if the port is the port range--->
							<cfelseif refind("[0-9]{1,4}[-][0-9]{1,4}",port)>
				 				 <cfinvoke component="#security#" method="deleteSecuredIPPort">
				   				    <cfinvokeargument name="directory" value="#directory#">
				 					<cfinvokeargument name="ip" value="#trim(ip)#">
								 	<cfinvokeargument name="port" value="#trim(port)#">
									<cfinvokeargument name="portType" value="range">
							     </cfinvoke>
								 <cfset deletePorts=deletePorts & IPPorts & " ">
							<cfelse>
								<cfinvoke component="#security#" method="deleteSecuredIPPort">
				    				<cfinvokeargument name="directory" value="#directory#">
									<cfinvokeargument name="IP" value="#trim(ip)#">
									<cfinvokeargument name="PORT" value="#trim(port)#">
								</cfinvoke>
								<cfset deletePorts=deletePorts & IPPorts & " ">
							</cfif>
					</cfloop>
				</cfif>
			<cfelse>
			<!---check the port is valid--->
				<cfloop index="IPPortName" list="#IPPortlist#">
					<!---get the port number --->
					<cfset port=right(IPPortName,len(IPPortName)-find(":",IPPortName))>
					<!---delete theIPPort name from the IPPortlist if it's port is not in valid range--->
					<cfif port LT -65535 or port GT 65535>
					  <cfset IPPortlist=listdeleteat(IPPortlist,ListFindNoCase(IPPortlist,IPPortName))>
					  <cfset unSecurableIPPorts=unSecurableIPPorts & IPPortName & " ">
					</cfif>
				</cfloop>
			
			<!---set IPPort against already secured IPPort--->
				<!---add IPPort:loop throught pass in IPPortlist against exist IPPortlist--->
				<cfloop list="#IPPortlist#" index="IPPortName">
				<!---if can't find the IPPort in exist  IPPort list,add it--->
				 	<cfif ListFindNoCase(allSecuredIPPorts,trim(IPPortname)) EQ 0>
					 <!---seperate ip and port--->
					<cfset ip=left(IPPortName,find(":",IPPortName)-1)>
					<cfset port=right(IPPortName,len(IPPortName)-find(":",IPPortName))>
						<!---check if the port is This port and higher --->
						<cfif right(port,1) EQ "-">
				 			<cfinvoke component="#security#" method="setSecuredIPPort">
				    			<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="higher">
							</cfinvoke>
						<!---check if the port is The port and lower--->
						<cfelseif left(port,1) EQ "-">
							<cfinvoke component="#security#" method="setSecuredIPPort">
				   				<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="lower">
						    </cfinvoke>
				 		<!---check if the port is the port range--->
				 		<cfelseif refind("[0-9]{1,4}[-][0-9]{1,4}",port)>
							<cfinvoke component="#security#" method="setSecuredIPPort">
				    		    <cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="range">
							</cfinvoke>
				 		<!---otherwise single port--->
						<cfelse>
				 			<cfinvoke component="#security#" method="setSecuredIPPort">
				    			<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="single">
							</cfinvoke>	
						</cfif>
				     </cfif>
				 </cfloop>
				
				<!---trim the spaces in list items--->
				<cfset newIPPortlist="">
				<cfloop index="IPPortname" list="#IPPortlist#">
					<cfset newIPPortlist=ListAppend(newIPPortlist,trim(IPPortname),",")>
				</cfloop>
				<cfset IPPortlist=newIPPortlist>
				
				<cfif trim(allSecuredIPPorts) NEQ "No secured IP/Ports">
				<cfloop list="#allSecuredIPPorts#" index="SecuredIPPort">
					<!---delete existing IPPorts if it is not in the list--->
					<cfif ListFindNoCase (IPPortlist,SecuredIPPort) EQ 0>
					<!---seperate ip and port--->
					<cfset ip=left(SecuredIPPort,find(":",SecuredIPPort)-1)>
				    <cfset port=right(SecuredIPPort,len(SecuredIPPort)-find(":",SecuredIPPort))>
					<!---check if the port is This port and higher --->
						<cfif right(port,1) EQ "-">
							 <cfinvoke component="#security#" method="deleteSecuredIPPort">
				    			<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="higher">
								<cfset deletePorts=deletePorts & SecuredIPPort & " ">
							 </cfinvoke>
								<!---check if the port is The port and lower--->
						<cfelseif left(port,1) EQ "-">
							 <cfinvoke component="#security#" method="deleteSecuredIPPort">
				   				<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="lower">
								<cfset deletePorts=deletePorts & SecuredIPPort & " ">
							 </cfinvoke>
				 <!---check if the port is the port range--->
				 		<cfelseif refind("[0-9]{1,4}[-][0-9]{1,4}",port)>
							 <cfinvoke component="#security#" method="deleteSecuredIPPort">
				    			<cfinvokeargument name="directory" value="#directory#">
				 				<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="range">
								<cfset deletePorts=deletePorts & SecuredIPPort & " ">
				 			 </cfinvoke>
				 <!---else the port is single--->
						<cfelse>
							<cfinvoke component="#security#" method="deleteSecuredIPPort">
				 				<cfinvokeargument name="directory" value="#directory#">
								<cfinvokeargument name="ip" value="#trim(ip)#">
								<cfinvokeargument name="port" value="#trim(port)#">
								<cfinvokeargument name="portType" value="single">
								<cfset deletePorts=deletePorts & SecuredIPPort & " ">
				    		</cfinvoke>	
						</cfif>
				 	</cfif>
				 </cfloop>
				 </cfif>
			</cfif>
		<!---return current IPPort list--->
				<cfset returnIPPortlist=getSecuredIPPorts(adminpassword,directory)>
				<cfset returnIPPortlist=xmltowddx(returnIPPortlist)>
				<cfwddx input="#returnIPPortlist#" output="returnIPPortlist" action="wddx2cfml">
			<cfif unSecurableIPPorts NEQ "">
			<cfset returnIPPortlist=returnIPPortlist & "," & "invalid port: " & unSecurableIPPorts>
				<cfif deletePorts NEQ "">
					<cfset returnIPPortlist=returnIPPortlist & "," & "deleted IP/ports: " & deletePorts>
				</cfif>
			<cfelse>
				
				
			</cfif>
			<cfset message=SetXMLResponse("true","0","OK","#returnIPPortlist#")>
			<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
<!---set sandbox securedforders--->
<!---get Secured IP Ports--->
	<CFFUNCTION access="remote" name="getSecuredFolders" returntype="string" hint="return detail of all secured folders of the sandbox. the return sting is a xml string">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="Specifies the sandbox directory">
		<cfset directory=trim(directory)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.security" name="security">
			<CFINVOKE component="#security#" method="getSecuredFolders" returnvariable="result">
			<cfinvokeargument name="directory" value="#directory#">
			</cfinvoke>
			<cfif arraylen(result) EQ 0>
			<cfwddx input="No secured folder" output="resultString" action="cfml2wddx">
			 <cfset message = SetXMLResponse("false","2","#resultString#")>
			 <cfreturn message>
			<cfelse>
			<cfwddx input="#result#" action="cfml2wddx" output="SecuredFolders">
			<cfset message=SetXMLResponse("true","0","OK","#SecuredFolders#")>
			<cfreturn message>
			</cfif>	

		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
	
	<!---set secured folders--->
		<CFFUNCTION access="remote" name="setSecuredFolder" returntype="string" hint="set secured folder of the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="specifies the sandbox directory">
		<cfargument name="folder" required="Yes" type="string" hint="specifies the folder you want to secure">
		<cfargument name="fileRead" type="boolean" required="yes" hint="read permission">
		<cfargument name="fileWrite" type="boolean" required="yes" hint="write permission">
		<cfargument name="fileExecute" type="boolean" required="yes" hint="execute permission">
		<cfargument name="fileDelete" type="boolean" required="yes" hint="delete permission">
		<cfset directory=trim(directory)>
		<cfset folder=trim(folder)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cftry>
			 	<cfobject component="cfide.adminapi.security" name="security">
				<!---insert/update secured folder--->
				<cfinvoke component="#security#" method="setSecuredFolder">
					<cfinvokeargument name="directory" value="#directory#">
					<cfinvokeargument name="folder" value="#folder#">
					<cfinvokeargument name="fileRead" value="#fileRead#">
					<cfinvokeargument name="fileWrite" value="#fileWrite#">
					<cfinvokeargument name="fileExecute" value="#fileExecute#">
					<cfinvokeargument name="fileDelete" value="#fileDelete#">
				</cfinvoke>
				
				<!---get permission list from wddx packet--->
				<cfparam name="permissions" default="">
				<cfset folders=getSecuredFolders(adminpassword,directory)>
				<cfset folders=xmltowddx(folders)>
				<cfset xmldoc=xmlparse(folders)>
				<cfset xmltop=#xmldoc.XmlRoot.data.array#>
				<cfloop from="1" to="#arraylen(xmltop.struct)#" index="i">
						<cfif xmltop.struct[i].var[2].string.XmlText EQ folder>
							<cfset permissions=#xmltop.struct[i].var[1].string.XmlText#>
	 					</cfif>
				</cfloop>
				<cfset message=SetXMLResponse("true","0","OK","Operation=Secure folder, Directory=#directory#, folder=#folder#, permissions=#permissions#")>
				
		  	<cfcatch>
				<cfset message=debugger(method="setSecuredFolder",error=cfcatch,args=arguments)>
				<cfreturn message>
			</cfcatch>
			</cftry>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			
		</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		
		</CFIF>
		<cfset debugger(args=arguments)>
		<cfreturn message>
	</cffunction>
	
	<!---delete secured directory--->
	<cffunction name="deleteSecuredFolder" access="remote" returntype="string" hint="delete secured folder of the sandbox">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="directory" required="Yes" type="string" hint="specifies the sandbox directory"> 
		<cfargument name="folder" required="Yes" type="string" hint="specifies the secured folder you want to delete">
		<cfset directory=trim(directory)>
		<cfset folder=trim(folder)>
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cftry>
			<cfobject component="cfide.adminapi.security" name="security">
			<cfinvoke component="#security#" method="deleteSecuredFolder">
				<cfinvokeargument name="directory" value="#directory#">
				<cfinvokeargument name="folder" value="#folder#">
			</cfinvoke>
			<cfcatch>
				<cfset message=SetXMLResponse("false","2","Delete secure folder fail","Operation=Delete secure folder, Directory=#directory#, folder=#folder#")>
				<cfreturn message>
			</cfcatch>
			</cftry>
			<cfset message=SetXMLResponse("true","0","OK","Operation=Delete secure folder, Directory=#directory#, folder=#folder#")>
			<cfreturn message>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
		<cfreturn message>
		</cfif>
		<cfelse>
		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
		<cfreturn message>
		</CFIF>
	</cffunction>
</cfcomponent>
