<cfcomponent displayname="cf7mapping" hint="create coldfusion mappings" extends="cfide.adminapi.webservice.cf7Datasource">
<!---mapping functions--->
	<!---get any mapping information function--->
	<CFFUNCTION name="getMappings" access="remote" returntype="string" hint="get the map path of a mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="No" type="string" hint="Specifies the map name of the mapping">
		<cfset mapName=trim(mapName)>
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.extensions" name="extensions">
			<cfif mapName EQ "*">
				<CFINVOKE component="#extensions#" method="getMappings" returnvariable="mappings"/>
				<cfset mapNames=StructKeyList(mappings)>
				<cfreturn mapNames>
			<cfelse>
				<CFINVOKE component="#extensions#" method="getMappings" returnvariable="mappings">
					<cfinvokeargument name="mapName" value="#mapName#">
				</cfinvoke>
				<cfset message=SetXMLResponse("true","0","OK","#mappings[mapName]#")>
				<cfreturn message>
			</cfif>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
	 		<cfreturn message>
		</CFIF>
	</cffunction>	
	
	<!---set mapping--->
		<CFFUNCTION name="setMapping" access="remote" returntype="string" hint="add a new mapping or change mapping path. If the mapname already exist, update mappath, otherwise add new mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="Yes" type="string">
		<cfargument name="mapPath" required="Yes" type="string">
		<cfset mapName=trim(mapName)>
		<cfset mapPath=trim(mapPath)>

		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<cfif DirectoryExists(mapPath)>
				<CFOBJECT component="cfide.adminapi.extensions" name="extensions">
				<CFINVOKE component="#extensions#" method="setMapping">
				<cfinvokeargument name="mapName" value="#mapName#">
				<cfinvokeargument name="mapPath" value="#mapPath#">
				</cfinvoke>
				<cfset message=SetXMLResponse("true","0","OK")>
				<cfreturn message>	
			<cfelse>
				<cfset message=SetXMLResponse("false","2","Invalid map path")>
				<cfreturn message>
			</cfif>
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			 <cfreturn message>
		</CFIF>
	</cffunction>
	
		<!---delete mapping--->
		<CFFUNCTION name="deleteMapping" access="remote" returntype="String" hint="delete mapping">
		<cfargument name="adminpassword" required="Yes" type="string">
		<cfargument name="mapName" required="Yes" type="string">
		<!---login with admin password--->
		<!---check if log in--->
		<cfif checkIP()>
		<CFIF adminLogin(adminPassword)>
			<CFOBJECT component="cfide.adminapi.extensions" name="extensions">
			<CFINVOKE component="#extensions#" method="deleteMapping">
			<cfinvokeargument name="mapName" value="#mapName#">
			</cfinvoke>
			<cfset message=SetXMLResponse("true","0","OK")>
			<cfreturn message>	
		<cfelse>
			<cfset message=SetXMLResponse("false","2","coldfusion server administrator password is wrong!")>
			<cfreturn message>
		</cfif>
		<cfelse>
	 		<cfset message=SetXMLResponse("false","2","Your IP is not allowed!")>
			 <cfreturn message>
		</CFIF>
	</cffunction>
</cfcomponent>